//Vesola's main script by DirkTheHusky
//First time coding a character on my own. It may not be as good as Dirk and Whirl but it should do fine
//I'll let you guys decide if I succeed or not =P
//Like Dirk, I'll also be putting the names of the coders that coded other stuff for her

//Lua assistance + optimizations + bugfixes from Lactozilla
//Any other lua pieces that were reused from Dirk and Whirl belong to their respectful coders. 

//Vesola's Stinger Follow Object (SMS Alfredo)

addHook("FollowMobj", function(player, mobj)
	if not (player.mo and player.mo.valid) return end
	
	local backwards = -5*FRACUNIT
	local zoffs = 0
	
	if not mobj.skin
		mobj.skin = player.mo.skin
		mobj.state = S_VESOLASTING_NOROTATE
		mobj.movecount = -1
		
		local chickenwing = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_VESOLA_WING)
		chickenwing.tracer = player.mo
		chickenwing.reactiontime = 1
		mobj.wingleft = chickenwing
		
		chickenwing = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_VESOLA_WING)
		chickenwing.tracer = player.mo
		chickenwing.reactiontime = 2
		mobj.wingright = chickenwing
	end

	mobj.color = player.mo.color
	mobj.threshold = player.mo.z
	mobj.movecount = player.panim
	mobj.angle = player.drawangle
	mobj.scale = player.mo.scale // This already calls P_SetScale, silly.
	mobj.radius = player.mo.radius
	mobj.height = player.mo.height
	mobj.rollangle = player.mo.rollangle
	zoffs = FixedMul(zoffs, mobj.scale)
	
	if (player.mo.eflags & MFE_VERTICALFLIP)
		mobj.eflags = $ | MFE_VERTICALFLIP
		mobj.flags2 = $ | MF2_OBJECTFLIP
		zoffs = player.mo.height - mobj.height - zoffs
	else
		mobj.eflags = $ & ~MFE_VERTICALFLIP
		mobj.flags2 = $ & ~MF2_OBJECTFLIP
	end
	
	if player.mo.state == S_PLAY_ROLL
	or (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
	or (player.mo.state >= S_PLAY_NIGHTS_TRANS1 and player.mo.state <= S_PLAY_NIGHTS_TRANS6)
	or player.mo.state == S_PLAY_NIGHTS_FLY
	or player.mo.state == S_PLAY_NIGHTS_DRILL
	or player.mo.state == S_PLAY_NIGHTS_STUN
	or player.mo.state == S_PLAY_NIGHTS_PULL
	or player.mo.state == S_PLAY_NIGHTS_ATTACK
	or player.guard
	or (player.dirk_frozen)
	or (player.isxmomentum and player.mo.state == S_PLAY_FACEPLANT)
	or (player.isxmomentum and player.mo.state == S_PLAY_TRICKUP)
	or (player.isxmomentum and player.mo.state == S_PLAY_TRICKDOWN)
	or (player.isxmomentum and (player.mo.state >= S_PLAY_HYPERTRNS_1 and player.mo.state <= S_PLAY_HYPERTRNS_6))
		mobj.flags2 = $ | MF2_DONTDRAW
	else
		mobj.flags2 = $ & ~MF2_DONTDRAW
	end
	
	if player.mo.state == S_PLAY_JUMP
	or player.mo.state == S_PLAY_SPRING
	or player.mo.state == S_PLAY_FALL 
	or player.mo.state == S_PLAY_FLY
	or player.mo.state == S_PLAY_FLY_TIRED
		if player.mo.momz > 0 
			mobj.state = S_VESOLASTING_MINUSROTATE
			if player.mo.momz < 1*FRACUNIT
				mobj.frame = A
			elseif player.mo.momz >= 1*FRACUNIT and player.mo.momz < 2*FRACUNIT
				mobj.frame = B
			elseif player.mo.momz >= 2*FRACUNIT and player.mo.momz < 3*FRACUNIT
				mobj.frame = C
			elseif player.mo.momz >= 3*FRACUNIT and player.mo.momz < 20*FRACUNIT
				mobj.frame = D
			elseif player.mo.momz >= 20*FRACUNIT and player.mo.momz < 40*FRACUNIT
				mobj.frame = E
			elseif player.mo.momz >= 40*FRACUNIT
				mobj.frame = F
			end
		end
		if player.mo.momz < 0 
			mobj.state = S_VESOLASTING_PLUSROTATE
			if player.mo.momz > -1*FRACUNIT
				mobj.frame = A
			elseif player.mo.momz < -1*FRACUNIT and player.mo.momz >= -2*FRACUNIT
				mobj.frame = B
			elseif player.mo.momz < -2*FRACUNIT and player.mo.momz >= -3*FRACUNIT
				mobj.frame = C
			elseif player.mo.momz < -3*FRACUNIT and player.mo.momz >= -20*FRACUNIT
				mobj.frame = D
			elseif player.mo.momz < -20*FRACUNIT and player.mo.momz >= -40*FRACUNIT
				mobj.frame = E
			elseif player.mo.momz < -40*FRACUNIT
				mobj.frame = F
			end
		end
	end
	if player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RIDE
		mobj.state = S_VESOLASTING_NOROTATE
	elseif player.panim == PA_RUN
		mobj.state = S_VESOLASTING_PLUSROTATE
		mobj.frame = B
	elseif player.panim == PA_PAIN
		mobj.state = S_VESOLASTING_PAIN
	elseif player.panim == PA_GASP
		mobj.state = S_VESOLASTING_GASP
	elseif player.panim == PA_EDGE
		mobj.state = S_VESOLASTING_EDGE
	end
	if player.mo.state == S_PLAY_WAIT
		mobj.spriteyoffset = -16*FRACUNIT
	elseif player.mo.state == S_PLAY_RIDE
		mobj.spriteyoffset = -8*FRACUNIT
	elseif player.mo.state == S_PLAY_PUSH
		mobj.spriteyoffset = -6*FRACUNIT
	else
		mobj.spriteyoffset = 0
	end

	if player.mo.state == S_PLAY_STING
		if player.mo.hornettime == 1
			mobj.state = S_VESOLASTING_STRIKE1
			mobj.spriteyoffset = -4*FRACUNIT
		end
		if player.mo.hornetsting > 1
			mobj.state = S_VESOLASTING_STRIKE4
		end
		if mobj.state == S_VESOLASTING_STRIKE2
			mobj.spriteyoffset = 8*FRACUNIT
		elseif mobj.state == S_VESOLASTING_STRIKE3
			mobj.spriteyoffset = -8*FRACUNIT
		elseif mobj.state == S_VESOLASTING_STRIKE4
			mobj.spriteyoffset = -8*FRACUNIT
		end
	end
		
	P_TeleportMove(mobj,
	player.mo.x + P_ReturnThrustX(mobj, mobj.angle, FixedMul(backwards, mobj.scale)),
	player.mo.y + P_ReturnThrustY(mobj, mobj.angle, FixedMul(backwards, mobj.scale)),
	player.mo.z + zoffs)
	
	return true
end, MT_VESOLA_STINGER)

local function removemobj(mobj)
	if mobj and mobj.valid then
		P_RemoveMobj(mobj)
	end
end

addHook("MobjRemoved", function(mo)
	if mo.valid then
		removemobj(mo.wingleft)
		removemobj(mo.wingright)
	end
end, MT_VESOLA_STINGER)

//Vesola's Wings (SMS Alfredo)

//Function for the wing rotation (DirkTheHusky)

local function wingflap(wing, mo)

	local player = mo.player
	
	if wing and wing.valid
		if wing.wingtime == nil
			wing.wingtime = 0
		end
		if wing.wingflapup == nil
			wing.wingflapup = 0
		end
		if wing.wingflapdown == nil
			wing.wingflapdown = 0
		end
		if wing.wingtime <= 0
			wing.flapup = 1
			wing.flapdown = 0
		end
		
		//Fast wing movement
		
		if mo.state == S_PLAY_WALK
		or mo.state == S_PLAY_RUN
		or mo.state == S_PLAY_FLY
		or mo.state == S_PLAY_FLY_TIRED
		or mo.state == S_PLAY_SPRING
		or mo.state == S_PLAY_JUMP
		or mo.state == S_PLAY_FALL
		or mo.state == S_PLAY_PUSH
			if wing.wingtime >= TICRATE
				wing.flapdown = 1
				wing.flapup = 0
			end
			if wing.flapup
				wing.wingtime = $+24
			end
			if wing.flapdown
				wing.wingtime = $-24
			end
		else
			wing.wingtime = 0
		end
	end
	return false
end

addHook("MobjThinker", function(mobj)
	if not mobj.reactiontime return end
	
	local dir = ((mobj.reactiontime-1) and 1 or -1)
	
	A_CapeChase(mobj, 1 + 22*FRACUNIT, -4*FRACUNIT)
	
	if mobj and mobj.valid and mobj.tracer and mobj.tracer.valid and mobj.tracer.player
		local player = mobj.tracer.player
		
		if not mobj.skin
			mobj.skin = player.mo.skin
			mobj.sprite = SPR_PLAY
			mobj.sprite2 = SPR2_BNCE
			mobj.frame = (mobj.reactiontime-1)|FF_PAPERSPRITE|FF_TRANS30
		end
		
		mobj.radius = player.mo.radius
		mobj.height = player.mo.height
		mobj.scale = player.mo.scale
		mobj.color = player.mo.color
		mobj.flags2 = $|MF2_LINKDRAW
		mobj.rollangle = player.mo.rollangle
		
		wingflap(mobj, player.mo) --Make the wings flap
		
		if mobj.reactiontime == 1
			mobj.angle = $-ANGLE_90*dir+(ANG2*mobj.wingtime)
		elseif mobj.reactiontime == 2
			mobj.angle = $-ANGLE_90*dir-(ANG2*mobj.wingtime)
		end
		
		--if mobj.reactiontime == 2
			--wingflap(mobj)
		--end
		
		--mobj.angle = $-ANGLE_90*dir+(ANG2*mobj.wingtime)
		--mobj.angle = $-ANGLE_90*dir
		
		//We don't need to wings to be paper sprited in every animation.
		
		if player.mo.state == S_PLAY_ROLL
		or (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
		or (player.mo.state >= S_PLAY_NIGHTS_TRANS1 and player.mo.state <= S_PLAY_NIGHTS_TRANS6)
		or player.mo.state == S_PLAY_NIGHTS_FLY
		or player.mo.state == S_PLAY_NIGHTS_DRILL
		or player.mo.state == S_PLAY_NIGHTS_STUN
		or player.mo.state == S_PLAY_NIGHTS_PULL
		or player.mo.state == S_PLAY_NIGHTS_ATTACK
		or player.guard
		or (player.dirk_frozen)
		or (player.isxmomentum and player.mo.state == S_PLAY_FACEPLANT)
		or (player.isxmomentum and (player.mo.state >= S_PLAY_HYPERTRNS_1 and player.mo.state <= S_PLAY_HYPERTRNS_6))
			mobj.flags2 = $ | MF2_DONTDRAW
		else
			mobj.flags2 = $ & ~MF2_DONTDRAW
		end
		
		//In some circumstances, we move the wings to be aligned with the body.
		
		if player.mo.state == S_PLAY_WAIT
			mobj.spriteyoffset = -16*FRACUNIT
		elseif player.mo.state == S_PLAY_PAIN
			mobj.spriteyoffset = -24*FRACUNIT
		elseif player.mo.state == S_PLAY_RIDE
			mobj.spriteyoffset = -8*FRACUNIT
		elseif player.mo.state == S_PLAY_STING
			mobj.spriteyoffset = -8*FRACUNIT
		elseif player.mo.state == S_PLAY_PUSH
			mobj.spriteyoffset = -6*FRACUNIT
		else
			mobj.spriteyoffset = 0
		end
	
		if not (player.followmobj and player.followmobj.valid
		and player.followmobj.type == MT_VESOLA_STINGER)
		or player.guard
			P_KillMobj(mobj)
		end
	end
end, MT_VESOLA_WING)

// Thinker for the Flower Trampoline

//Reusing lua from Dirk. This should tell us if where standing on the platform or not. (Lach + Lactozilla)
//----------------------------------------
local function nearPlatform(mo, flower)
	return (mo.eflags & MFE_VERTICALFLIP) and abs(mo.z + mo.height - flower.z) < 2*mo.scale
	or not (mo.eflags & MFE_VERTICALFLIP) and abs(mo.z - flower.z - flower.height) < 2*mo.scale
end

addHook("MobjCollide", function(flower, mo)
	if flower.growtime < 1 then return end
	if mo.player then
		local jumpfrombelow = (mo.momz > 0)
		if (mo.eflags & MFE_VERTICALFLIP) then
			jumpfrombelow = (mo.momz < 0)
		end
		if jumpfrombelow then
			return false
		elseif nearPlatform(mo, flower)
		and P_IsObjectOnGround(mo)
		and not mo.player.beeflight
		and not (mo.player.pflags & PF_JUMPDOWN)
			mo.flowerjumpready = true
			mo.beetrampoline = flower
		end
	end
end, MT_FLOWERTRAMPOLINEPLAT)

//----------------------------------------
//Some Object thinkers (Lactozilla)
//----------------------------------------

addHook("MobjMoveCollide", function(mo, flower)
	if mo.player then
		return false
	end
end, MT_FLOWERTRAMPOLINEPLAT)

local function spawnstem(flowerstem, z)
	local stem = P_SpawnMobj(flowerstem.x, flowerstem.y, z, MT_FLOWERTRAMPOLINESTEM)
	stem.target = flowerstem.target
	stem.angle = flowerstem.angle
	return stem
end

local function getstemheight(flowerstem)
	return mobjinfo[MT_FLOWERTRAMPOLINESTEM].height
end

local function getstemzpos(flowerstem)
	local z = flowerstem.z
	if flowerstem.eflags & MFE_VERTICALFLIP then
		z = $-getstemheight()
	end
	return z
end

local function updatestem(flower, stem, z)
	P_TeleportMove(stem, flower.x, flower.y, z)
	stem.flags2 = $|(flower.flags2 & MF2_OBJECTFLIP)
	stem.eflags = $|(flower.eflags & MFE_VERTICALFLIP)
	stem.scale = ((flower.stemtime*flower.scale)/8)
	stem.spriteyscale = ((flower.stemtime*FRACUNIT)/8)
end

local function changebloomstate(flowerstem, state)
	flowerstem.flowerbloomstate = state
	if (flowerstem.target and flowerstem.target.valid and flowerstem.target.player) then
		flowerstem.target.flowerbloomstate = state
	end
end

local function changespikestate(vine, state)
	vine.vinespikestate = state
	if (vine.target and vine.target.valid and vine.target.player) then
		vine.target.vinespikestate = state
	end
end

local function setSlopeOrigin(mobj)
	if mobj.lastX ~= mobj.x
	or mobj.lastY ~= mobj.y
	or mobj.lastZ ~= mobj.z then
		mobj.floorspriteslope.o = {
			x = mobj.x,
			y = mobj.y,
			z = mobj.z
		}
		mobj.lastX = mobj.x
		mobj.lastY = mobj.y
		mobj.lastZ = mobj.z
	end
end

local function setSlopeXYDirection(mobj, angle)
	if angle ~= mobj.floorspriteslope.xydirection then
		mobj.floorspriteslope.xydirection = angle
	end
end

local function setSlopeZUnit(mobj, zdelta)
	if zdelta ~= mobj.floorspriteslope.zdelta then
		mobj.floorspriteslope.zdelta = zdelta
	end
end

//----------------------------------------

//Actual thinker action for the flower trampoline (DirkTheHusky + Lactozilla)

local function plantflowerstem(flowerstem)
	local x = flowerstem.x
	local y = flowerstem.y
	local z = nil
	
	local player = nil
	local pmo = nil
	if (flowerstem.target and flowerstem.target.valid and flowerstem.target.player) then
		pmo = flowerstem.target
		player = pmo.player
		
		flowerstem.flags2 = $|(pmo.flags2 & MF2_OBJECTFLIP)
		flowerstem.eflags = $|(pmo.eflags & MFE_VERTICALFLIP)
	end
	
	if flowerstem.eflags & MFE_VERTICALFLIP then
		z = P_CeilingzAtPos(x, y, flowerstem.z, flowerstem.height)
	else
		z = P_FloorzAtPos(x, y, flowerstem.z, flowerstem.height)
	end

	P_TeleportMove(flowerstem, x, y, z)

	//Random time checks for them to get out of nil.
	if flowerstem.flowerbloomstate == nil then
		flowerstem.flowerbloomstate = 0
	end
	if flowerstem.spawntime == nil then
		flowerstem.spawntime = 0
	end
	if flowerstem.bloomtime == nil then
		flowerstem.bloomtime = 0
	end
	if flowerstem.growtime == nil then
		flowerstem.growtime = 0
	end
	if flowerstem.isblooming == nil then
		flowerstem.isblooming = 0
	end
	if flowerstem.stemtime == nil
		flowerstem.stemtime = 0
	end
	if flowerstem.jumptime == nil
		flowerstem.jumptime = 0
	end
	if flowerstem.stemgrowtime == nil
		flowerstem.stemgrowtime = 0
	end
	
	//Time limits so we don't overpass the functions.
	if flowerstem.growtime > 16
		flowerstem.growtime = 16
	end
	if flowerstem.growtime < 0
		flowerstem.growtime = 0
	end
	if flowerstem.flowerbloomstate > 0
		flowerstem.spawntime = $+1
	end
	if flowerstem.stemtime
		if flowerstem.flowerbloomstate == 2
			flowerstem.stemtime = $+1
		elseif flowerstem.flowerbloomstate == 4
			flowerstem.stemtime = $-2
		end
		if flowerstem.stemtime > 8
			flowerstem.stemtime = 8
		end
	end
	if flowerstem.stemtime2
		if flowerstem.flowerbloomstate == 2
			flowerstem.stemtime2 = $+1
		elseif flowerstem.flowerbloomstate == 4
			flowerstem.stemtime2 = $-1
		end
		if flowerstem.stemtime2 > 8
			flowerstem.stemtime2 = 8
		end
	end
	
	if flowerstem.jumptime < 0
		flowerstem.jumptime = 0
	end
	
	if flowerstem.stemgrowtime < 0
		flowerstem.stemgrowtime = 0
	end
	
	local growtime = flowerstem.growtime
	
	local flowerbloom = nil
	if flowerstem.flowerbloom and flowerstem.flowerbloom.valid then
		flowerbloom = flowerstem.flowerbloom
	end
	
	//We start planting those flowers in
	if flowerstem.flowerbloomstate == 1 then
		if flowerstem.spawntime == 1
			S_StartSound(flowerstem, sfx_s3k6f)
			flowerbloom = P_SpawnMobj(flowerstem.x, flowerstem.y, flowerstem.z, MT_FLOWERTRAMPOLINEPLAT)
			flowerbloom.scale = flowerstem.scale
			flowerbloom.target = flowerstem.target
			flowerbloom.tracer = flowerstem
			flowerbloom.flags2 = $|MF2_SPLAT|MF2_DONTDRAW
			flowerbloom.renderflags = $|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
			flowerbloom.angle = flowerstem.angle
			flowerbloom.growtime = growtime
			flowerstem.flowerbloom = flowerbloom
		end
		if flowerstem.spawntime == TICRATE/2 then
			changebloomstate(flowerstem, 2)
		end
	end
	
	if flowerbloom then
		flowerbloom.growtime = growtime
		flowerbloom.flags2 = $|(flowerstem.flags2 & MF2_OBJECTFLIP)
		flowerbloom.eflags = $|(flowerstem.eflags & MFE_VERTICALFLIP)
		
		local z = flowerbloom.z
		if not (flowerstem.launched and growtime >= 16) then
			local flip = P_MobjFlip(flowerbloom)
			z = growtime*(flowerstem.scale*4)
			z = flowerstem.z + $*flip
			z = $+(2*flowerstem.scale*flip)
		end
		P_TeleportMove(flowerbloom, flowerstem.x, flowerstem.y, z)
	end
	
	//The flower pops out from the ground
	if flowerstem.flowerbloomstate == 2
	
		if flowerbloom then
			flowerbloom.flags2 = $1 & ~MF2_DONTDRAW
			flowerbloom.scale = ((growtime*flowerstem.scale)/16)
			
			if growtime == 1
				S_StartSound(flowerstem, sfx_s3k9b)
				flowerstem.state = S_FLOWERDIRTUPRISE
				flowerstem.fuse = 5*TICRATE
				local pedrad = mobjinfo[MT_FLOWERTRAMPOLINEPEDAL].radius - (8*FRACUNIT)
				//DirkTheHusky: Literally took me 50 minutes to figure out tables. Thank you Lactozilla.
				flowerstem.leaves = {}
				for petalpiece=1,12 do
					local pedang = flowerbloom.angle + ANG30*petalpiece
					local rad = FixedInt(pedrad) - 10
					local x = flowerbloom.x + FixedMul(rad*cos(pedang), flowerbloom.scale)
					local y = flowerbloom.y + FixedMul(rad*sin(pedang), flowerbloom.scale)
					local leaf = P_SpawnMobj(x, y, flowerbloom.z-(FRACUNIT*P_MobjFlip(flowerstem)), MT_FLOWERTRAMPOLINEPEDAL)
					leaf.angle = pedang + ANGLE_90
					leaf.scale = flowerstem.scale
					leaf.flags2 = MF2_SPLAT
					leaf.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
					leaf.eflags = flowerbloom.eflags
					leaf.target = flowerbloom.target
					
					local slope = P_CreateFloorSpriteSlope(leaf)
					setSlopeOrigin(leaf)
					setSlopeXYDirection(leaf, leaf.angle)
					
					flowerstem.leaves[petalpiece] = leaf
				end
			end
		end
		
		//Plant those stems in
		if growtime == 1 then
			flowerstem.stem = spawnstem(flowerstem, (getstemzpos(flowerstem)))
			flowerstem.stemtime = 1
		elseif growtime == 9 then
			local z = (getstemheight()*P_MobjFlip(flowerstem))
			flowerstem.stem2 = spawnstem(flowerstem, getstemzpos(flowerstem)+FixedMul(z, flowerstem.scale))
			flowerstem.stem2.state = S_FLOWERTRAMPOLINESTEM2
			flowerstem.stemtime2 = 1
		end
		
		if growtime == 16 then
			changebloomstate(flowerstem, 3)
		end
		
		flowerstem.bloomtime = 15
	//The flower blooms
	elseif flowerstem.flowerbloomstate == 3
		if flowerstem.isblooming == 0 then
			flowerstem.isblooming = 1
		end
		if flowerstem.isblooming == 1 then
			flowerstem.bloomtime = $-1
			if flowerstem.bloomtime == -5 then
				flowerstem.isblooming = 2
			end
		end
		if flowerstem.isblooming == 2
			flowerstem.bloomtime = $+1
			if flowerstem.bloomtime == 0
				flowerstem.isblooming = 3
			end
		end
	end
	
	local stem = flowerstem.stem
	local z = getstemzpos(flowerstem)
	if stem and stem.valid then
		updatestem(flowerstem, stem, z)
	end
	stem = flowerstem.stem2
	if stem and stem.valid then
		z = $+FixedMul(flowerstem.scale, getstemheight()*P_MobjFlip(stem))
		updatestem(flowerstem, stem, z)
	end
	if flowerstem.leaves then
		for petalpiece=1,12 do
			local leaf = flowerstem.leaves[petalpiece]
			if leaf and leaf.valid then
				z = $+FixedMul(flowerstem.scale, getstemheight()*P_MobjFlip(leaf))
				updatestem(flowerstem, leaf, z)
			end
		end
	end
	
	//Misc. stuff for the Mobjs
	if flowerstem.leaves then
		for petalpiece=1,12 do
			local leaf = flowerstem.leaves[petalpiece]
			if (not leaf) or (leaf and not leaf.valid) then
				continue
			end
			
			leaf.flags2 = $|(flowerstem.flags2 & MF2_OBJECTFLIP)
			leaf.eflags = $|(flowerstem.eflags & MFE_VERTICALFLIP)
			
			local flip = P_MobjFlip(leaf)
			local z = growtime*(flowerstem.scale*4)
			leaf.z = flowerstem.z+(z*flip)
			leaf.z = $+(flowerstem.scale*flip)
			
			if flowerbloom then
				leaf.scale = flowerbloom.scale
			end
			
			if pmo then
				leaf.color = pmo.color
			end
			
			if flowerstem.jumptime then
				leaf.z = flowerbloom.z
			end
			
			setSlopeOrigin(leaf)
			
			local zdelta = -FixedDiv(flowerstem.bloomtime*FRACUNIT, 15*FRACUNIT)*flip
			setSlopeZUnit(leaf, zdelta)
			setSlopeXYDirection(leaf, leaf.angle)
		end
	end
	
	if flowerstem.flowerbloomstate == 2
		flowerstem.growtime = $+1
		flowerstem.bloomtime = 15
	end
	
	// Boing, the flower launch sequence!
	if flowerstem.launched == true
		flowerstem.jumptime = $-1
		local jumptime = flowerstem.jumptime
		if flowerbloom and flowerstem.growtime >= 16 then
			if jumptime == 15 then
				P_SetObjectMomZ(flowerbloom, 6*FRACUNIT, false)
			elseif jumptime == 8 then
				P_SetObjectMomZ(flowerbloom, -6*FRACUNIT, false)
			elseif jumptime == 1 then
				flowerbloom.momz = 0
			end
		end
		if jumptime > 8 then
			flowerstem.stemgrowtime = $+1
		else
			flowerstem.stemgrowtime = $-1
		end
		if jumptime == 1
			flowerstem.stemgrowtime = 0
			flowerstem.spawntime = 5*TICRATE
		end
		if stem and stem.valid
		and jumptime then
			stem.spriteyscale = FRACUNIT+((FRACUNIT*flowerstem.stemgrowtime)/6)
			if jumptime == 1
				stem.spriteyscale = FRACUNIT
			end
		end
	end

	if flowerstem.spawntime >= 5*TICRATE
	and flowerstem.flowerbloomstate == 3
		if pmo then
			pmo.flowerspawned = false
			pmo.flowerbloomstate = 0
		end
		changebloomstate(flowerstem, 4)
	end
	//Despawn the flower back to the ground
	if flowerstem.flowerbloomstate == 4
		flowerstem.growtime = $-1
		if flowerbloom and flowerbloom.valid then
			flowerbloom.scale = ((flowerstem.growtime*flowerstem.scale)/16)
		end
		if flowerstem.stem and flowerstem.stem.valid
		and (flowerstem.growtime < 9) then
			flowerstem.stem.scale = ((flowerstem.stemtime*flowerstem.scale)/8)
			flowerstem.stem.spriteyscale = ((flowerstem.stemtime*flowerstem.scale)/8)
		end
		if flowerstem.stem2 and flowerstem.stem2.valid
		and (flowerstem.growtime > 8) then
			flowerstem.stem2.spriteyscale = ((flowerstem.stemtime2*FRACUNIT)/8)
		end
		
		if flowerstem.growtime == 1
			removemobj(flowerstem.stem)
			removemobj(flowerstem.stem2)
			removemobj(flowerstem.flowerbloom)
			for petalpiece=1,12 do
				removemobj(flowerstem.leaves[petalpiece])
			end
			if pmo then
				pmo.flowerspawned = false
				pmo.flowerbloomstate = 0
			end
			P_RemoveMobj(flowerstem)
		end
	end
	return false
end

addHook("MobjThinker", plantflowerstem, MT_FLOWERTRAMPOLINESPAWN)


//Action thinkers for Vine spikes (DirkTheHusky)

local MAXHEIGHTDIFF = MAXSTEPMOVE*4

local function dirtspawn(vinespike, x, y)
	if x == nil then
		x = vinespike.x
	end
	if y == nil then
		y = vinespike.y
	end
	
	local verticalflip = (vinespike.eflags & MFE_VERTICALFLIP)
	local z = nil
	if verticalflip then
		z = P_CeilingzAtPos(x, y, vinespike.z, vinespike.height)
	else
		z = P_FloorzAtPos(x, y, vinespike.z, vinespike.height)
	end
	
	local dirt = P_SpawnMobj(x, y, z, MT_MINUSDIRT)
	if abs(dirt.z - z) > MAXHEIGHTDIFF then
		P_RemoveMobj(dirt)
		return nil
	elseif P_CheckDeathPitCollide(dirt) then
		P_RemoveMobj(dirt)
		return nil
	end
	
	dirt.target = vinespike
	dirt.scale = vinespike.scale
	dirt.flags2 = $|(vinespike.flags2 & MF2_OBJECTFLIP)
	dirt.eflags = $|verticalflip
	
	S_StartSound(dirt, sfx_s3k6f)
	
	return dirt
end


local function spikespawn(vinespike, player, x, y)
	if x == nil then
		x = vinespike.x
	end
	if y == nil then
		y = vinespike.y
	end
	
	local verticalflip = (vinespike.eflags & MFE_VERTICALFLIP)
	local z = nil
	if verticalflip then
		z = P_CeilingzAtPos(x, y, vinespike.z, vinespike.height)
	else
		z = P_FloorzAtPos(x, y, vinespike.z, vinespike.height)
	end
	
	local vine = P_SpawnMobj(x, y, z, MT_VINESPIKE)
	if abs(vine.z - z) > MAXHEIGHTDIFF then
		P_RemoveMobj(vine)
		return nil
	elseif P_CheckDeathPitCollide(vine) then
		P_RemoveMobj(vine)
		return nil
	end
	
	vine.target = player.mo
	vine.scale = player.mo.scale
	vine.flags2 = $|(vinespike.flags2 & MF2_OBJECTFLIP)
	vine.eflags = $|verticalflip
	vine.growtime = 0
	
	return vine
end

//Function for the vine spike to play its despawn animation.

local function spikedespawn(spike)
	if spike and spike.valid then
		spike.shrinktime = 8
		spike.shrinking = true
	end
end

local function vinespike(vinespike)
	local x = vinespike.x
	local y = vinespike.y
	local z = nil
	
	local player = nil
	local pmo = nil
	if (vinespike.target and vinespike.target.valid and vinespike.target.player) then
		pmo = vinespike.target
		player = pmo.player
		
		vinespike.flags2 = $|(pmo.flags2 & MF2_OBJECTFLIP)
		vinespike.eflags = $|(pmo.eflags & MFE_VERTICALFLIP)
	end
	
	if vinespike.eflags & MFE_VERTICALFLIP then
		z = P_CeilingzAtPos(x, y, vinespike.z, vinespike.height)
	else
		z = P_FloorzAtPos(x, y, vinespike.z, vinespike.height)
	end

	P_TeleportMove(vinespike, x, y, z)
	
	if vinespike.vinetime == nil then
		vinespike.vinetime = 0
	end
	if vinespike.planttime == nil then
		vinespike.planttime = 0
	end
	if vinespike.vineidle == nil then
		vinespike.vineidle = 0
	end
	if vinespike.vineshrinktime == nil then
		vinespike.vineshrinktime = 0
	end
	
	local battle = (CBW_Battle and CBW_Battle.BattleGametype())
	local distance = FixedMul(vinespike.scale, 160*FRACUNIT)
	local angle = vinespike.angle
	
	if vinespike.vinespikestate == 1
		vinespike.planttime = $+1
		if vinespike.planttime == 1
			vinespike.dirt1 = dirtspawn(vinespike)
		elseif vinespike.planttime == 6 then
			local x2 = vinespike.x + FixedMul(distance, cos(angle))
			local y2 = vinespike.y + FixedMul(distance, sin(angle))
			vinespike.dirt2 = dirtspawn(vinespike, x2, y2)
		elseif vinespike.planttime == 11 then
			local x3 = vinespike.x + FixedMul(distance*2, cos(angle))
			local y3 = vinespike.y + FixedMul(distance*2, sin(angle))
			vinespike.dirt3 = dirtspawn(vinespike, x3, y3)
		end
		if vinespike.planttime == 12
			changespikestate(vinespike, 2)
		end
	//Spawn in the vines one by one
	elseif vinespike.vinespikestate == 2
		vinespike.vinetime = $+1
		if vinespike.dirt1 and vinespike.vinetime == 1
			S_StartSound(vinespike.dirt1, sfx_s3k9b)
			vinespike.dirt1.state = S_FLOWERDIRTUPRISE
			vinespike.dirt1.scale = 3*vinespike.scale/2
			vinespike.dirt1.fuse = 4*TICRATE
			vinespike.vine1 = spikespawn(vinespike, player, vinespike.x, vinespike.y)
			if vinespike.vine1 and (G_GametypeHasTeams() or battle) then
				vinespike.vine1.sprite = SPR_FSKC
				vinespike.vine1.color = vinespike.target.color
				if (vinespike.target.ctfteam == 2)
					vinespike.vine1.color = skincolor_bluering
				elseif (vinespike.target.ctfteam == 1)
					vinespike.vine1.color = skincolor_redring
				end
			end
		elseif vinespike.dirt2 and vinespike.vinetime == 6 then
			S_StartSound(vinespike.dirt2, sfx_s3k9b)
			vinespike.dirt2.state = S_FLOWERDIRTUPRISE
			vinespike.dirt2.scale = 3*vinespike.scale/2
			vinespike.dirt2.fuse = 4*TICRATE
			local x2 = vinespike.x + FixedMul(distance, cos(angle))
			local y2 = vinespike.y + FixedMul(distance, sin(angle))	
			vinespike.vine2 = spikespawn(vinespike, player, x2, y2)
			if vinespike.vine2 and (G_GametypeHasTeams() or battle) then
				vinespike.vine2.sprite = SPR_FSKC
				vinespike.vine2.color = vinespike.target.color
				if (vinespike.target.ctfteam == 2)
					vinespike.vine2.color = skincolor_bluering
				elseif (vinespike.target.ctfteam == 1)
					vinespike.vine2.color = skincolor_redring
				end
			end
		elseif vinespike.dirt3 and vinespike.vinetime == 11 then
			S_StartSound(vinespike.dirt3, sfx_s3k9b)
			vinespike.dirt3.state = S_FLOWERDIRTUPRISE
			vinespike.dirt3.scale = 3*vinespike.scale/2
			vinespike.dirt3.fuse = 4*TICRATE
			local x3 = vinespike.x + FixedMul(distance*2, cos(angle))
			local y3 = vinespike.y + FixedMul(distance*2, sin(angle))
			vinespike.vine3 = spikespawn(vinespike, player, x3, y3)
			if vinespike.vine3 and (G_GametypeHasTeams() or battle) then
				vinespike.vine3.sprite = SPR_FSKC
				vinespike.vine3.color = vinespike.target.color
				if (vinespike.target.ctfteam == 2)
					vinespike.vine3.color = skincolor_bluering
				elseif (vinespike.target.ctfteam == 1)
					vinespike.vine3.color = skincolor_redring
				end
			end
		end
		
		local vine = nil
		local changestate = false
		
		if (vinespike.vine1 and vinespike.vine1.valid) then
			vine = vinespike.vine1
		end
		
		/*if vine and vine.growtime == 8 then
			changestate = true*/
		if vinespike.vinetime == 16 then
			changestate = true
		end
		
		if changestate then
			changespikestate(vinespike, 3)
			vinespike.vineshrinktime = 8
		end
	elseif vinespike.vinespikestate == 3
		vinespike.vineidle = $+1
		if vinespike.vineidle == 3*TICRATE
			if vinespike.vine1 and vinespike.vine1.valid 
				vinespike.vine1.shrinking = true
			end
			if vinespike.vine2 and vinespike.vine2.valid then
				vinespike.vine2.shrinking = true
			end
			if vinespike.vine3 and vinespike.vine3.valid then
				vinespike.vine3.shrinking = true
			end
			changespikestate(vinespike, 4)
		end
	//The spikes go back to the ground
	elseif vinespike.vinespikestate == 4
		vinespike.vineshrinktime = $-1
		if pmo and vinespike.vineshrinktime == 1
			pmo.spikespawned = false
		end
	end
end

addHook("MobjThinker", vinespike, MT_VINESPIKESPAWN)

addHook("MobjThinker", function(spike)
	if spike.shrinking == true
		if spike.shrinktime == nil
			spike.shrinktime = 8
		end
		if spike.shrinktime == 1
			P_RemoveMobj(spike)
			return
		end
		spike.spriteyscale = ((spike.shrinktime*FRACUNIT)/8)
		spike.shrinktime = $-1
	else
		if spike.growtime < 8 then
			spike.growtime = $+1
		end
		spike.spriteyscale = ((spike.growtime*FRACUNIT)/8)
		--spike.height = FixedMul((spike.growtime*FRACUNIT)/8, mobjinfo[thing.type].height)
	end
end, MT_VINESPIKE)

/*local launchablemobjs = {
	MT_BLUECRAWLA,
	MT_REDCRAWLA,
	MT_GFZFISH,
	MT_GOLDBUZZ,
	MT_REDBUZZ,
	MT_JETTBOMBER,
	MT_JETTGUNNER,
	MT_SKIM,
	MT_POPUPTURRET,
	MT_SPINCUSHION,
	MT_CRUSHSTACEAN,
	MT_BANPYURA,
	MT_JETJAW,
	MT_SNAILER,
	MT_VULTURE,
	MT_POINTY,
	MT_ROBOHOOD,
	MT_EGGGUARD,
	MT_GSNAPPER,
	MT_MINUS,
	MT_SPRINGSHELL,
	MT_YELLOWSHELL,
	MT_UNIDUS,
	MT_CANARIVORE,
	MT_PYREFLY,
	MT_PTERABYTE,
	MT_DRAGONBOMBER,
	MT_PENGUINATOR,
	MT_POPHAT,
	MT_SPINBOBERT,
	MT_CACOLANTERN,
	MT_HANGSTER,
	MT_BUMBLEBORE,
	MT_BUGGLE,
}*/

local function launchEnemy(mo, vine)
	mo.z = $ + (24<<FRACBITS * P_MobjFlip(mo))
	mo.launched = vine
	mo.baseSprite = mo.sprite
	mo.baseFrame = mo.frame
	mo.state = S_LAUNCHEDENEMY
end

//Thinker for when the object collides with the spike when it emerges

local function vinespiker(vine, touch)
	if not (vine.target and vine.target.valid)
	or (touch.z > (vine.z + vine.height))
	or (vine.z > (touch.z + touch.height))
	or not (touch.flags & (MF_ENEMY|MF_BOSS|MF_SHOOTABLE|MF_MONITOR))
	or touch == vine.target
	or touch.type == MT_PLAYER and not (G_RingSlingerGametype()) and not (CBW_Battle and CBW_Battle.BattleGametype())
	or (touch.player and touch.player.valid and (gametyperules & GTR_FRIENDLY or G_GametypeHasTeams() and touch.player.ctfteam == vine.target.player.ctfteam) and not CV_FindVar("friendlyfire").value)
		return
	end
	
	if touch.flags & MF_ENEMY
	and not (touch.flags & MF_BOSS) then //We don't apply this to boss fights. They should just damage them.
		if touch.health <= 1
		and not (touch.info.spawnhealth > 1)
		and vine.growtime < 8 then
			launchEnemy(touch, vine)
			return
		end
	end	
	
	if (vine.target and vine.target.valid) then
		P_DamageMobj(touch, vine, vine.target)
	else
		P_DamageMobj(touch)
	end
	vine.shrinking = true
end

addHook("MobjCollide", vinespiker, MT_VINESPIKE)
addHook("MobjMoveCollide", vinespiker, MT_VINESPIKE)
	

local function vinedamage(vine, inflictor, source)
	if inflictor.launched ~= nil
		return false
	end
end

addHook("ShouldDamage", vinedamage, MT_VINESPIKE)

//Abilites (DirkTheHusky + Lactozilla)


local function abilitycooldown(mo, tics)
	if mo and mo.valid then
		mo.abilitycooldown = tics
	end
end

addHook("AbilitySpecial", function(player)
	if player.mo.skin == "vesola"
		if not (player.pflags & PF_THOKKED)
		and not (player.gotflag or player.gotcrystal)
		and not (player.dirk_frozen)
		and not player.mo.hornetsting
		and not player.lightshot
		and not player.mo.abilityready == true
			player.pflags = $|PF_CANCARRY
			player.beeflight = 1
			player.mo.state = S_PLAY_FLY
			if not S_SoundPlaying(player.mo, sfx_drill1)
				S_StartSound(player.mo, sfx_drill1)
			end
		end
	end
end)

local function PlantFlower(player)
	local dist = (player.mo.radius * 10) + (player.speed * 4)
	local x = player.mo.x + FixedMul(dist, cos(player.mo.angle))
	local y = player.mo.y + FixedMul(dist, sin(player.mo.angle))
	local z = nil

	local verticalflip = (player.mo.eflags & MFE_VERTICALFLIP)
	if verticalflip then
		z = P_CeilingzAtPos(x, y, player.mo.z, player.mo.height)
	else
		z = P_FloorzAtPos(x, y, player.mo.z, player.mo.height)
	end

	local plantstem = P_SpawnMobj(x, y, z, MT_FLOWERTRAMPOLINESPAWN)
	/*if abs(plantstem.z - z) > MAXHEIGHTDIFF then
		S_StartSound(player.mo, sfx_notadd)
		P_RemoveMobj(plantstem)
		return false
	end*/
	if P_CheckDeathPitCollide(plantstem) then
		S_StartSound(player.mo, sfx_notadd, player)
		P_RemoveMobj(plantstem)
		//In case of player changes, reset them!
		player.normalspeed = skins["vesola"].normalspeed
		player.pflags = $ & ~PF_THOKKED
		player.mo.colorized = false
		player.mo.abilitycharge = 0
		player.mo.abilityready = false
		return false
	end
	
	plantstem.target = player.mo
	plantstem.tics = 10*TICRATE
	plantstem.angle = player.mo.angle + ANGLE_90
	plantstem.scale = player.mo.scale
	plantstem.flags2 = $|(player.mo.flags2 & MF2_OBJECTFLIP)
	plantstem.eflags = $|verticalflip
	player.mo.flowerspawned = true
	changebloomstate(plantstem, 1)
	
	local plantdirt = P_SpawnMobj(x, y, z, MT_MINUSDIRT)
	plantdirt.target = plantstem
	plantdirt.fuse = TICRATE/2
	plantdirt.scale = plantstem.scale
	plantdirt.flags2 = $|(player.mo.flags2 & MF2_OBJECTFLIP)
	plantdirt.eflags = $|verticalflip
	
	return true
end

local function SpawnSpike(player)
	if player.mo.spikespawned == true then return end
	
	local dist = (player.mo.radius * 10) + (player.speed * 4)
	local x = player.mo.x + FixedMul(dist, cos(player.mo.angle))
	local y = player.mo.y + FixedMul(dist, sin(player.mo.angle))
	local z = nil
	
	local verticalflip = (player.mo.eflags & MFE_VERTICALFLIP)
	if verticalflip then
		z = P_CeilingzAtPos(x, y, player.mo.z, player.mo.height)
	else
		z = P_FloorzAtPos(x, y, player.mo.z, player.mo.height)
	end
	
	/*if abs(z - player.mo.z) > MAXHEIGHTDIFF then
		S_StartSound(player.mo, sfx_notadd)
		return false
	end*/
	
	local spike = P_SpawnMobj(x, y, z, MT_VINESPIKESPAWN)
	if P_CheckDeathPitCollide(spike) then
		S_StartSound(player.mo, sfx_notadd, player)
		P_RemoveMobj(spike)
		//In case of player changes, reset them!
		player.normalspeed = skins["vesola"].normalspeed
		player.pflags = $ & ~PF_THOKKED
		player.mo.colorized = false
		player.mo.abilitycharge = 0
		player.mo.abilityready = false
		return false
	end
	spike.target = player.mo
	spike.tics = 10*TICRATE
	spike.angle = player.mo.angle
	spike.scale = player.mo.scale
	spike.flags2 = $|(player.mo.flags2 & MF2_OBJECTFLIP)
	spike.eflags = $|verticalflip
	changespikestate(spike, 1)
	player.mo.spikespawned = true
	return true
end

addHook("SpinSpecial", function(player)
	if player.mo.skin == "vesola"
		if P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.exiting != 0
		or player.powers[pw_carry]
		or (player.pflags & PF_SHIELDABILITY)
		or P_SuperReady(player)
		or player.mo.state == S_PLAY_SPRING
		or player.spectator
		or player.playerstate
		or not player.mo.health
		or (player.panim == PA_PAIN and not (player.pflags&PF_JUMPED))
		or player.mo.state == S_PLAY_GASP
		or player.mo.eflags&MFE_SPRUNG
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or player.isjettysyn
		or player.guard
		or player.airdodge
		or player.candodge
		or player.actionstate
		or player.powers[pw_nocontrol] > 0
		//or player.gotflagdebuff
		or player.mo.frostburnt or player.dirk_frozen
		or (player.isxmomentum and player.mo.state == S_PLAY_FACEPLANT)
		return end
		
		if player.mo.abilitycooldown == nil then
			player.mo.abilitycooldown = 0
		end
	
		if (player.mo.abilitycooldown > 0)
		and not (player.pflags & PF_SPINDOWN)
		and not player.mo.beeflying == true
		and not player.mo.hornetsting
		and not (player.pflags & PF_JUMPED)
			S_StartSound(player.mo, sfx_notadd, player)
		end
		
		if P_IsObjectOnGround(player.mo)
		and player.mo.abilitycooldown == 0
			player.mo.charging = true
		end
		
		if not P_IsObjectOnGround(player.mo)
		and (player.pflags & PF_JUMPED)
		and player.mo.hornettime == 0
		and not (player.pflags & PF_SPINDOWN)
			player.mo.hornetsting = 1
			player.hornetready = true
			player.pflags = $|PF_THOKKED
			S_StartSoundAtVolume(player.mo, sfx_stgsrk, 128)
			S_StartSound(player.mo, sfx_stgsrk)
			player.beeflight = 0
			player.isascending = false
			player.spinangle = player.drawangle
			P_SetObjectMomZ(player.mo, 2*FRACUNIT, false)
			player.mo.state = S_PLAY_STING
		end
	end
end)	
			
//The actual thinkers for Vesola's abilities. Some lua may be seen from Whirl coded by SMS Alfredo

local beeflighttime = 16*TICRATE
local beeflyspeed = 12*FRACUNIT/5

addHook("PlayerSpawn", function(player)
	if not player.mo then return end
	if not player.mo.valid then return end
	if player.mo.skin ~= "vesola" then return end

	player.normalspeed = skins["vesola"].normalspeed
	player.thrustfactor = skins["vesola"].thrustfactor
	player.mo.beeflying = false
	player.mo.flowerspawned = false
	player.mo.spikespawned = false
	player.mo.abilityready = false
	player.mo.charging = false
	player.mo.flowerbloomstate = 0
	player.mo.vinespikestate = 0
	player.mo.beeflighttime = beeflighttime
	player.mo.flowertrail = false
	player.mo.petaltwirltime = 0
	player.mo.abilitycooldown = 0
	player.mo.abilitycharge = 0
	player.mo.petalparticles = 0
end)

//Flower Trails. Reused from Whirl because I can.
local function P_FlowerTrail(mo)
    local ghost = P_SpawnMobj(mo.x, mo.y, mo.z, MT_FLOWERGHOST)
	
	if not (ghost and ghost.valid) return end

    P_SetScale(ghost, mo.scale)
    ghost.destscale = mo.scale

    if (mo.eflags & MFE_VERTICALFLIP)
        ghost.eflags = $|MFE_VERTICALFLIP
        ghost.z = $ + mo.height - ghost.height
    end

	ghost.skin = mo.skin
    ghost.colorized = true
    ghost.angle = mo.angle
    if mo.player
        ghost.angle = mo.player.drawangle
    end
    ghost.sprite = mo.sprite
    ghost.sprite2 = mo.sprite2
    ghost.frame = mo.frame
    ghost.tics = -1
    ghost.frame = $ & ~FF_TRANSMASK
	ghost.rollangle = mo.rollangle
	ghost.color = SKINCOLOR_ROSY
	--ghost.blendmode = AST_OVERLAY
	ghost.spritexoffset = mo.spritexoffset
    ghost.frame = $|tr_trans50<<FF_TRANSSHIFT
	ghost.fuse = 5

    if (mo.flags2 & MF2_OBJECTFLIP)
        ghost.flags = $|MF2_OBJECTFLIP
    end

    if (mo.player and mo.player.followmobj)
        local ghost2 = P_SpawnGhostMobj(mo.player.followmobj)
        ghost2.tracer = ghost
        ghost.tracer = ghost2
        ghost2.flags2 = $|(mo.player.followmobj.flags2 & MF2_LINKDRAW)
		ghost2.color = SKINCOLOR_ROSY
		--ghost2.blendmode = AST_OVERLAY
		ghost2.fuse = 5
    end

    return ghost
end

addHook("PlayerThink", function(player)
	if not player.mo then return end
	if not player.mo.valid then return end
	if player.mo.skin ~= "vesola" then return end

	if player.mo.beeflying == nil then
		player.mo.beeflying = false
	end
	
	if player.mo.flowerspawned == nil then
		player.mo.flowerspawned = false
	end
	if player.mo.spikespawned == nil then
		player.mo.spikespawned = false
	end
	
	if player.mo.flowerbloomstate == nil then
		player.mo.flowerbloomstate = 0
	end
	if player.mo.vinespikestate == nil then
		player.mo.vinespikestate = 0
	end
	
	if player.mo.beeflighttime == nil then
		player.mo.beeflighttime = beeflighttime
	end
	if player.mo.petaltwirltime == nil then
		player.mo.petaltwirltime = 0
	end
	
	if player.mo.abilitycooldown == nil
		player.mo.abilitycooldown = 0
	end
	
	if player.mo.abilitycharge == nil
		player.mo.abilitycharge = 0
	end
	
	if player.mo.flowertrail == nil
		player.mo.flowertrail = false
	end
	
	if player.mo.petalparticles == nil
		player.mo.petalparticles = 0
	end
	
	if player.mo.petalparticles > 6
		player.mo.petalparticles = 0
	end
	
	//We rotate her around during edge frames
	if player.mo.state == S_PLAY_EDGE
		if (player.pflags & PF_ANALOGMODE)
			player.mo.angle = player.mo.angle+ANGLE_180
		else
			player.drawangle = player.mo.angle+ANGLE_180
		end
	end

	if (player.petaltwirl == nil) then
		player.petaltwirl = {}
	end
	if player.spinangle == nil then
		player.spinangle = player.drawangle
	end
	
	if player.mo.abilitycooldown > 0 then
		player.mo.abilitycooldown = $-1
	end
		
	if player.mo.abilitycooldown == 2 then
		S_StartSound(player.mo, sfx_flwfil, player)
		player.mo.spikespawned = false
		player.mo.color = SKINCOLOR_WHITE
		player.mo.colorized = true
	elseif player.mo.abilitycooldown == 1 then
		player.mo.color = player.skincolor
		player.mo.colorized = false
	end
	
	if player.mo.petaltwirltime > 10 then
		player.mo.petaltwirltime = 10
	elseif player.mo.petaltwirltime < 0 then
		player.mo.petaltwirltime = 0
	end
		
	//Copied from Whirl's code because why not. She can't use her abilities in those states anyways. (SMS Alfredo)
	if P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	or player.exiting != 0
	or player.powers[pw_carry]
	or (player.pflags & PF_SHIELDABILITY)
	or P_SuperReady(player)
	or player.spectator
	or player.playerstate
	or not player.mo.health
	or (player.panim == PA_PAIN and not (player.pflags&PF_JUMPED))
	or player.mo.state == S_PLAY_GASP
	--or player.mo.eflags&MFE_SPRUNG
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.candodge
	or player.airdodge
	or player.actionstate
	or player.powers[pw_nocontrol] > 0
	//or player.gotflagdebuff
	or player.mo.frostburnt or player.dirk_frozen
	or (player.isxmomentum and player.mo.state == S_PLAY_FACEPLANT)
		player.charflags = $|SF_NOJUMPDAMAGE
		player.charflags = $&~SF_STOMPDAMAGE
		player.mo.colorized = false
		player.normalspeed = skins["vesola"].normalspeed
		player.mo.hornetsting = 0
		player.mo.hornettime = 0
		player.beeflight = 0
		player.mo.beeflying = false
		player.mo.flowerlaunched = false
		player.mo.beeflighttime = 8*TICRATE
		player.mo.petaltwirltime = 0
		player.mo.abilityready = false
		player.mo.abilitycharge = 0
		removemobj(player.energy)
		removemobj(player.petalparticle)
		S_StopSoundByID(player.mo, sfx_s3kcal)
	return end
	
	//Spin actions
	
	if not (player.beeflight or player.mo.hornetsting)
	and not (player.dirk_frozen)
	and not player.isjettysyn
	and not (player.pflags & PF_THOKKED)
	and not player.mo.abilitycooldown
	and not (player.mo.eflags&MFE_SPRUNG)
		if player.cmd.buttons&BT_SPIN
		and player.mo.charging == true
			if player.beeflight == 0
			and player.mo.abilitycooldown == 0
			and not player.mo.beeflying == true
			--and not abilityDone == true //In case if cooldown is zero and the objects are present.
				player.mo.abilityready = true
				player.mo.abilitycharge = $+1
			end
		else
			if player.mo.abilitycharge > 0
				local abilityDone = false
				if player.mo.abilitycharge < TICRATE
					if SpawnSpike(player) then
						abilityDone = true
						S_StopSoundByID(player.mo, sfx_flwcrg)
						if (CBW_Battle and CBW_Battle.BattleGametype())
							abilitycooldown(player.mo, 4*TICRATE)
						else
							abilitycooldown(player.mo, TICRATE/2)
						end
					else
						player.mo.abilityready = false
					end
				elseif PlantFlower(player) then
					abilityDone = true
					if (CBW_Battle and CBW_Battle.BattleGametype())
						abilitycooldown(player.mo, 4*TICRATE)
					end
				else
					player.mo.abilityready = false
					player.mo.charging = false
				end
				if abilityDone then
					player.mo.abilityready = false
					player.mo.charging = false
				end
				player.normalspeed = skins["vesola"].normalspeed
				--player.pflags = $ & ~PF_THOKKED
				player.mo.colorized = false
				player.mo.abilitycharge = 0
				player.mo.petalparticles = 0
				S_StopSoundByID(player.mo, sfx_flwcrg)
				S_StopSoundByID(player.mo, sfx_s3kcal)
				removemobj(player.energy)
				removemobj(player.petalparticle)
			end
		end
	end
	
	
	if player.mo.abilitycharge > 0
		--player.pflags = $|PF_THOKKED
		player.normalspeed = 24*FRACUNIT
		player.mo.petalparticles = $+1
		
		if player.mo.petalparticles == 1
			player.petalparticle = P_SpawnMobj(player.mo.x + P_RandomRange(-32, 32)*player.mo.scale, player.mo.y + P_RandomRange(-32, 32)*player.mo.scale, (player.mo.z+(8*player.mo.scale*P_MobjFlip(player.mo))+player.mo.momz), MT_PETALPARTICLE)
			player.petalparticle.state = S_PETALATTACK
			player.petalparticle.scale = player.mo.scale
			player.petalparticle.fuse = TICRATE
			player.petalparticle.color = player.mo.color
			player.petalparticle.target = player.mo
			player.petalparticle.eflags = $ | (player.mo.eflags & MFE_VERTICALFLIP)
			
			P_SetObjectMomZ(player.petalparticle, 3*FRACUNIT, false)
			--P_TryMove(player.petalparticle, player.mo.x, player.mo.y, false)
		end
		
		--player.petalparticle.momx = player.mo.momx
		--player.petalparticle.momy = player.mo.momy
		
		if player.mo.abilitycharge == 1 then
			S_StartSound(player.mo, sfx_flwcrg)
		end
		if player.mo.abilitycharge == TICRATE then
			S_StartSound(player.mo, sfx_flwchg)
			
			player.energy = P_SpawnMobj(player.mo.x+player.mo.momx, player.mo.y+player.mo.momy, player.mo.z+player.mo.momz, MT_CHARGINGVFX)
			player.energy.scale = player.mo.scale/2
			player.energy.color = player.mo.color
			player.energy.skin = player.mo.skin
			player.energy.state = S_CHARGINGMOVE
			player.energy.eflags = player.mo.eflags
			player.energy.target = player.mo
			if player.energy and player.energy.valid
				P_TeleportMove(player.energy, player.mo.x+(player.mo.momx*2/3), player.mo.y+(player.mo.momy*2/3), player.mo.z+(10*player.mo.scale)+(player.mo.momz*2/3))
			end
		end
		if player.mo.abilitycharge > TICRATE
			if not S_SoundPlaying(player.mo, sfx_s3kcal)
				S_StartSound(player.mo, sfx_s3kcal)
			end
			
			if player.energy and player.energy.valid
				P_TeleportMove(player.energy, player.mo.x+(player.mo.momx*2/3), player.mo.y+(player.mo.momy*2/3), player.mo.z+(10*player.mo.scale)+(player.mo.momz*2/3))
			end
			
			if (leveltime % 2)
				player.mo.colorized = true
			else
				player.mo.colorized = false
			end
		end
	end
		
	//Related on tics for her flight
	if player.beeflight == 1
	and (player.pflags & PF_JUMPED)
	and not (player.pflags&PF_THOKKED)
	and not player.gotflagdebuff
	and not player.mo.abilityready == true
	and not (player.mo.eflags&MFE_SPRUNG)
		player.mo.beeflying = true
		if player.mo.beeflighttime >= 1
			player.thrustfactor = 8
			
			if player.cmd.buttons&BT_JUMP
				player.isascending = true
				if player.mo.beeflighttime > 0
				and player.isascending == true
					if (player.mo.eflags & MFE_UNDERWATER)
						P_SetObjectMomZ(player.mo, beeflyspeed/4, true)
					else
						P_SetObjectMomZ(player.mo, beeflyspeed/2, true)
					end
					player.mo.state = S_PLAY_FLY
					if not player.powers[pw_super]
						player.mo.beeflighttime = $-8
					end
					player.mo.petaltwirltime = $+1
					if player.mo.momz > 10*FRACUNIT
						if (CBW_Battle and CBW_Battle.BattleGametype())
							if (player.mo.eflags & MFE_UNDERWATER)
								P_SetObjectMomZ(player.mo, (beeflyspeed*3)*P_MobjFlip(player.mo), false)
							else
								P_SetObjectMomZ(player.mo, (beeflyspeed*4)*P_MobjFlip(player.mo), false)
							end
						else
							if (player.mo.eflags & MFE_UNDERWATER)
								P_SetObjectMomZ(player.mo, (beeflyspeed*3)*P_MobjFlip(player.mo), false)
							else
								P_SetObjectMomZ(player.mo, (beeflyspeed*5)*P_MobjFlip(player.mo), false)
							end
						end
					end
					player.drawangle = player.spinangle+ANG10*(leveltime)
					local pedrad = 64*FRACUNIT
					for barrier=1,8 do
						local pedang = player.drawangle + (ANGLE_45*barrier)
						local rad = FixedInt(pedrad) - 10
						local x = player.mo.x + FixedMul(rad*cos(pedang), player.mo.scale)
						local y = player.mo.y + FixedMul(rad*sin(pedang), player.mo.scale)
						local z = (4*player.mo.scale)
						local flip = (P_MobjFlip(player.mo) < 0)
						if flip then
							local z1 = (player.mo.z + player.mo.height) - z
							local z2 = player.mo.z - 16*player.mo.scale
							z = player.mo.petaltwirltime*(FRACUNIT/10)
							z = FixedMul(FRACUNIT - z, z1) + FixedMul(z, z2)
						else
							z = $ + player.mo.z
						end
						local petal = P_SpawnMobj(x+player.mo.momx, y+player.mo.momy, z+player.mo.momz, MT_PETALTWIRLPIECE)
						petal.angle = pedang + ANGLE_90
						petal.scale = player.mo.petaltwirltime*(player.mo.scale/10)
						petal.fuse = 2
						petal.color = player.mo.color
						petal.skin = player.mo.skin
						petal.frame = FF_PAPERSPRITE
						if flip then
							petal.frame = $ | FF_VERTICALFLIP
						end
						petal.eflags = $ | (player.mo.eflags & MFE_VERTICALFLIP)
						petal.target = player.mo
						player.petaltwirl[barrier] = petal
						player.petaltwirl[barrier].eflags = player.mo.eflags
					end
					
					if player.mo.momz*P_MobjFlip(player.mo) < -1*FRACUNIT
						if (CBW_Battle and CBW_Battle.BattleGametype()) //We nerf the fly Z speed in battle.
							beeflyspeed = 10*FRACUNIT/7
						else
							beeflyspeed = 12*FRACUNIT/2
						end
					else
						beeflyspeed = 12*FRACUNIT/5
					end
				end
			else
				if not (P_IsObjectOnGround(player.mo) and player.mo.eflags & MFE_JUSTHITFLOOR)
					player.isascending = false
					player.mo.petaltwirltime = $-1
					player.mo.state = S_PLAY_FLY_TIRED
					player.mo.frame = leveltime/(abs(5 - player.mo.momz/10/FRACUNIT) or 1) % 2
					P_SetObjectMomZ(player.mo, FRACUNIT/10, true)
					S_StopSoundByID(player.mo, sfx_drill1)
					if not player.powers[pw_super]
						player.mo.beeflighttime = $-1
					end
				end
			end
			if player.mo.beeflighttime < 0
				player.mo.state = S_PLAY_FALL
				player.mo.beeflighttime = 0
			end
		//Flight's done. We can't use it until we land.
		else
			if not (P_IsObjectOnGround(player.mo) and player.mo.eflags & MFE_JUSTHITFLOOR)
				S_StartSound(player.mo, sfx_s3ka0)
			end
			player.mo.state = S_PLAY_FALL
			player.pflags = $|PF_THOKKED
			player.isascending = false
			S_StopSoundByID(player.mo, sfx_drill1)
			player.thrustfactor = skins["vesola"].thrustfactor
			
			if P_IsObjectOnGround(player.mo)
				player.mo.state = S_PLAY_WALK
			end
		end
	end
	//Sting Strike. Attack with your stinger to smash your enemies.
	if player.mo.hornetsting
	and not player.mo.abilityready == true
		player.mo.state = S_PLAY_STING
		player.thrustfactor = skins["vesola"].thrustfactor
		if player.hornetready == true
			--player.mo.momx = $*1/2
			--player.mo.momy = $*1/2
			player.mo.hornettime = $+1
		end
		
		if player.mo.hornettime < 12
			if (player.mo.eflags&MFE_SPRUNG)
				player.mo.state = S_PLAY_SPRING
				player.mo.hornetsting = 0
				player.mo.hornettime = 0
			end
		end
		
		if player.mo.hornettime > 11
		and player.mo.hornetsting == 1
			S_StartSound(player.mo, sfx_zoom)
			P_SetObjectMomZ(player.mo, -16*FRACUNIT, false)
			player.mo.hornetsting = 2
		end
		if player.mo.hornetsting > 1
			player.hornetready = false
			player.charflags = $&~SF_NOJUMPDAMAGE
			player.charflags = $|SF_STOMPDAMAGE
			player.drawangle = player.spinangle+ANG10*(leveltime*3)
			local stingtrail = P_SpawnGhostMobj(player.mo)
			stingtrail.fuse = 4
			stingtrail.tracer.fuse = 4
			stingtrail.color = player.mo.color
			stingtrail.colorized = true
			
			if player.mo.eflags&MFE_SPRUNG
				player.mo.state = S_PLAY_SPRING
				player.mo.hornetsting = 0
				player.mo.hornettime = 0
				player.mo.momx = $*5/4
				player.mo.momy = $*5/4
				player.mo.momz = $*5/4
				S_StartSound(player.mo, sfx_sprong)
			end
			
					
			//Re-used from Whirl's script. She can shatter bustable FOFs in the dash state
			local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
			if sectorthing.valid and player.mo.state == S_PLAY_STING then
				for fof in sectorthing.ffloors()
					if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
					and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale) then
						EV_CrumbleChain(player.sectorthing, fof)
					end
				end
			end
		end
		if P_IsObjectOnGround(player.mo) or player.mo.eflags&MFE_SPRUNG
		or (P_IsObjectOnGround(player.mo) and player.mo.eflags & MFE_JUSTHITFLOOR)
		or player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectInGoop(player.mo)
		or player.powers[pw_nocontrol]
		--or (player.mo.hornetsting > 1 and player.mo.momz*P_MobjFlip(player.mo) > 0)
			if player.mo.state == S_PLAY_STING
				player.mo.state = S_PLAY_FALL
				player.mo.hornetsting = 0
				player.mo.hornettime = 0
				player.hornetready = true
				player.thrustfactor = skins["vesola"].thrustfactor
				player.charflags = $|SF_NOJUMPDAMAGE
				player.charflags = $&~SF_STOMPDAMAGE
			end
		end
	end
	
	if player.mo.flowertrail == true
	and (leveltime % 3)
		P_FlowerTrail(player.mo)
	end
	
	//In case we land on the ground in the wrong state.
	if (P_IsObjectOnGround(player.mo) and player.mo.eflags & MFE_JUSTHITFLOOR)
	and player.mo.hornetsting == 1
	and player.mo.state == S_PLAY_STING
		player.mo.state = S_PLAY_STND
		player.charflags = $|SF_NOJUMPDAMAGE
		player.charflags = $&~SF_STOMPDAMAGE
		player.pflags = $&~PF_CANCARRY
		player.mo.hornetsting = 0
		player.mo.hornettime = 0
		player.hornetready = false
	end
	
	//We landed. Time to reset everything.
	if P_IsObjectOnGround(player.mo) or player.mo.eflags&MFE_SPRUNG
	or (P_IsObjectOnGround(player.mo) and player.mo.eflags & MFE_JUSTHITFLOOR)
	or player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectInGoop(player.mo)
		player.charflags = $|SF_NOJUMPDAMAGE
		player.charflags = $&~SF_STOMPDAMAGE
		player.pflags = $ & ~PF_THOKKED
		player.pflags = $&~PF_CANCARRY
		player.mo.hornetsting = 0
		player.mo.hornettime = 0
		player.beeflight = 0
		player.hornetready = false
		player.thrustfactor = skins["vesola"].thrustfactor
		player.mo.beeflying = false
		player.mo.flowerlaunched = false
		player.mo.flowertrail = false
		player.mo.beeflighttime = 8*TICRATE
		player.mo.petaltwirltime = 0
	end
end)

//Thinker for the abilities for the player themselves.

addHook("MobjThinker", function(mo)
	local player = mo.player
	
	if player.cmd.buttons&BT_JUMP
	and mo.flowerjumpready == true
		local trampoline = mo.beetrampoline
		if trampoline and trampoline.valid
		and not trampoline.launched then
			S_StartSound(mo, sfx_sprong)
			if (CBW_Battle and CBW_Battle.BattleGametype())
				mo.momz = $*6/4
			elseif player.powers[pw_super]
				mo.momz = $*11/4
			else
				mo.momz = $*9/4
			end
			mo.flowerjumpready = false
			mo.flowerlaunched = true
			mo.flowertrail = true
			local tracer = trampoline.tracer
			if tracer and tracer.valid then
				tracer.launched = true
				tracer.jumptime = 16
			end
		end
	end
	
	mo.flowerjumpready = false
	
	if mo.momz < 0
	and mo.flowertrail == true
		mo.flowertrail = false
	end
end, MT_PLAYER)