/*Vesola's Bot abilites
	by DirkTheHusky
Edit from Dirk's Bot abilites
	by Lach
*/

freeslot("S_INDICATORSPIN",
	"S_INDICATORFLOWER1",
	"S_INDICATORFLOWER2",
	"S_INDICATORFLOWER3",
	"S_INDICATORFLOWER4",
	"S_INDICATORFLOWER5",
	"S_INDICATORFLOWER6",
	"S_INDICATORFLOWER7",
	"S_INDICATORFLOWER8",
	"SPR_SPII",
	"SPR_FLWI"
)

states[S_INDICATORSPIN] = {
	sprite = SPR_SPII,
	frame = A|FF_ANIMATE,
	tics = -1,
	nextstate = S_NULL,
	var1 = 3,
	var2 = 4,
}

states[S_INDICATORFLOWER1] = {
	sprite = SPR_FLWI,
	frame = A,
	tics = 1,
	nextstate = S_INDICATORFLOWER1,
}

states[S_INDICATORFLOWER2] = {
	sprite = SPR_FLWI,
	frame = B,
	tics = 1,
	nextstate = S_INDICATORFLOWER2,
}

states[S_INDICATORFLOWER3] = {
	sprite = SPR_FLWI,
	frame = C,
	tics = 1,
	nextstate = S_INDICATORFLOWER3,
}

states[S_INDICATORFLOWER4] = {
	sprite = SPR_FLWI,
	frame = D,
	tics = 1,
	nextstate = S_INDICATORFLOWER4,
}

states[S_INDICATORFLOWER5] = {
	sprite = SPR_FLWI,
	frame = E,
	tics = 1,
	nextstate = S_INDICATORFLOWER5,
}

states[S_INDICATORFLOWER6] = {
	sprite = SPR_FLWI,
	frame = F,
	tics = 1,
	nextstate = S_INDICATORFLOWER6,
}

states[S_INDICATORFLOWER7] = {
	sprite = SPR_FLWI,
	frame = G,
	tics = 1,
	nextstate = S_INDICATORFLOWER7,
}

states[S_INDICATORFLOWER8] = {
	sprite = SPR_FLWI,
	frame = H,
	tics = 1,
	nextstate = S_INDICATORFLOWER8,
}

addHook("BotTiccmd", function(bot,cmd)
	local player = players[0]
	local mo = players[0].mo
	
	if player.exiting then  //Have we finished the level? If so, disable the bot ability
		return
	end
	
	if bot.mo and bot.mo.skin == "vesola" and players[0].mo
	
		if bot.mo.vesolaind
			local ind = bot.mo.vesolaind
			if bot.mo.abilitycharge == 0
				ind.state = S_INDICATORSPIN
				ind.frame = ((leveltime / 6) % 4)
			elseif bot.mo.abilitycharge > 0 and bot.mo.abilitycharge < 8
				ind.state = S_INDICATORFLOWER1
				ind.color = bot.mo.color
			elseif bot.mo.abilitycharge >= 8 and bot.mo.abilitycharge < 13
				ind.state = S_INDICATORFLOWER2
				ind.color = bot.mo.color
			elseif bot.mo.abilitycharge >= 13 and bot.mo.abilitycharge < 17
				ind.state = S_INDICATORFLOWER3
				ind.color = bot.mo.color
			elseif bot.mo.abilitycharge >= 17 and bot.mo.abilitycharge < 21
				ind.state = S_INDICATORFLOWER4
				ind.color = bot.mo.color
			elseif bot.mo.abilitycharge >= 21 and bot.mo.abilitycharge < 26
				ind.state = S_INDICATORFLOWER5
				ind.color = bot.mo.color
			elseif bot.mo.abilitycharge >= 26 and bot.mo.abilitycharge < 30
				ind.state = S_INDICATORFLOWER6
				ind.color = bot.mo.color
			elseif bot.mo.abilitycharge >= 30 and bot.mo.abilitycharge < 34
				ind.state = S_INDICATORFLOWER7
				ind.color = bot.mo.color
			elseif bot.mo.abilitycharge >= 34
				ind.state = S_INDICATORFLOWER8
				ind.color = bot.mo.color
			end
			
			if P_AproxDistance(bot.mo.z-mo.z,P_AproxDistance(bot.mo.x-mo.x,bot.mo.y-mo.y)) <= bot.mo.radius*2
			and player.speed == 0 and P_IsObjectOnGround(bot.mo)
				bot.mo.vesolaind.flags2 = $ & ~MF2_DONTDRAW
			else
				bot.mo.vesolaind.flags2 = $|MF2_DONTDRAW
			end
		else
			local ind = P_SpawnMobj(bot.mo.x, bot.mo.y, bot.mo.z, MT_OVERLAY)
			ind.target = bot.mo
			ind.state = S_INDICATORSPIN
			ind.flags2 = $|MF2_DONTDRAW
			bot.mo.vesolaind = ind
		end
		if player.cmd.buttons & BT_SPIN
		and P_IsObjectOnGround(bot.mo)
		and P_AproxDistance(bot.mo.z-mo.z,P_AproxDistance(bot.mo.x-mo.x,bot.mo.y-mo.y)) <= bot.mo.radius*2
			P_ResetPlayer(player)
			player.mo.momx = 0
			player.mo.momy = 0
			P_InstaThrust(player.mo,0,0)
			player.pflags = $|PF_STASIS
			player.powers[pw_nocontrol] = 1
			player.mo.state = S_PLAY_STND
			bot.mo.angle = player.mo.angle
			cmd.buttons = $ | BT_SPIN
		end
	end
end)
	
print("\n\132    /##\\\n\132   /####\\\n\132  /##/\\##\\\n\132 /##/  \\##\\\n\132/##/    \\##\\\n\132###      ###\n\132###      ###\n\132###      ###\n\132\\##\\    /##/\n\132 \\##\\  /##/\n\132  \\##\\/##/\n\132   \\####/\n\132    \\##/\n\n\130Team Kinetic v2.0.1\n")