//Whirl's SRB2 battle abilities and support by DirkTheHusky
//Man, this script is...a bit of a mess. How did I do?

local whirl_cooldown = TICRATE*6
local whirl_topspintime = TICRATE*5

local WhirlBattle = false
--local B = CBW_Battle

local function WhirlSpecial(mo,doaction,pressedaction)
	local player = mo.player
	
	if not(CBW_Battle.CanDoAction(player)) 
		player.actionstate = 0
	return end
	
	//Action Info
	player.actiontext = "Tornado Top"
	player.actionrings = 10

	if player.actionstate != 0 then 
		player.canguard = false
	end
	
	if player.actionstate == 0
		mo.spriteyoffset = 0
		if doaction == 1
			CBW_Battle.PayRings(player)
			mo.spriteyoffset = 10*FRACUNIT
			player.actionstate = 1
			mo.state = S_PLAY_SPINDASH
			S_StartSound(mo, sfx_cdfm11)
			player.spintime = whirl_topspintime
		end
	end
	if player.actionstate
		if player.spintime > 0 then
			player.spintime = $-1
		else
			player.spintime = 0
		end
		player.canguard = false
		if player.actionstate == 1
		and (player.spintime >= 1*TICRATE and player.spintime < 4*TICRATE)
			player.actionstate = 2
			mo.state = S_PLAY_DRILL
			P_InstaThrust(mo, mo.angle, 24*FRACUNIT)
			if not S_SoundPlaying(mo, sfx_s3kcal)
				S_StartSound(mo, sfx_s3kcal)
			end
		end
		if player.actionstate == 1
		or player.actionstate == 3
			mo.state = S_PLAY_SPINDASH
		end
		if player.actionstate == 2
			mo.state = S_PLAY_DRILL
			player.pflags = $|PF_THOKKED
			mo.friction = (29*FRACUNIT/35)
			player.acceleration = 96
			
			local beyblade = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			beyblade.target = mo
			beyblade.scale = mo.scale
			beyblade.color = mo.color
			beyblade.fuse = 9
			beyblade.tics = 9
			
			if (player.spintime > 0 and player.spintime < 1*TICRATE)
				player.actionstate = 3
				player.pflags = $&~(PF_THOKKED)
				S_StopSoundByID(mo, sfx_s3kc4l)
				mo.state = S_PLAY_SPINDASH
				mo.friction = (29*FRACUNIT/32)
				player.acceleration = skins[player.mo.skin].acceleration
			end
		end
		if player.spintime == 0
			player.actionstate = 0
			S_StopSoundByID(mo, sfx_s3kcal)
			mo.spriteyoffset = 0
			if P_IsObjectOnGround(mo)
				mo.state = S_PLAY_WALK
			else
				mo.state = S_PLAY_FALL
			end
			CBW_Battle.ApplyCooldown(player,whirl_cooldown)
			player.canguard = true
		end
	end
end

//Time for some beyblade. Reusing the bump stuff from his ram charge. Credit goes to SMS Alfredo
addHook("MobjMoveBlocked", function(mobj)
	if mobj and mobj.valid and mobj.player and mobj.skin == "whirl"
	and mobj.player.actionstate == 2
	and mobj.player.speed
		mobj.player.whirlbonkangle = mobj.player.drawangle
		P_InstaThrust(mobj, mobj.player.whirlbonkangle+ANGLE_180, 24*FRACUNIT)
		local particle = P_SpawnMobj(mobj.x, mobj.y, mobj.z+mobj.height, MT_PARTICLE)
		if particle and particle.valid
			particle.state = S_RAMSPARKS1
		end
		if P_RandomChance(FRACUNIT/50) then
			S_StartSound(mobj, sfx_whrbnk)
		else
			S_StartSound(mobj, sfx_s3k5f)
			S_StartSoundAtVolume(mobj, sfx_s3k59, 128)
		end
	end
end, MT_PLAYER)

local KineticExhaustW = function(player)
	if player.whirltornadojump == 1
		local maxtime = 4*TICRATE
		player.exhaustmeter = max(0,$-FRACUNIT/maxtime)
		if player.exhaustmeter <= 0
			player.whirltornadojump = 0
			player.mo.state = S_PLAY_FALL
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
	end
	return false
end

//Main Setup!			
			
addHook("ThinkFrame",function()
	if (CBW_Battle and not WhirlBattle)
		local function KineticPriorityW(player)
			if player.gotflagdebuff then //Dumb check to restore Whirl
				S_StopSoundByID(player.mo, sfx_s3kc4l)
				player.mo.spriteyoffset = 0
				player.spintime = 0
			end
			if player.whirltornadojump 
			and player.mo.state == S_PLAY_DRILL then
				CBW_Battle.SetPriority(player,3,2,"fang_tailbounce",1,2,"propeller drill")
			elseif player.whirlram and player.speed <= 15*FRACUNIT then
				//We don't dodge or guard when using this move
				CBW_Battle.SetPriority(player,0,1,"knuckles_glide",0,1,"Ram Charge")
			elseif player.whirlram and player.speed > 15*FRACUNIT then
				CBW_Battle.SetPriority(player,0,1,"knuckles_glide",1,2,"Ram Charge")
			elseif (player.actionstate == 1 or  player.actionstate == 3) then
				CBW_Battle.SetPriority(player,1,1,nil,1,1,"Tornado Top")
			elseif player.actionstate == 2 then
				CBW_Battle.SetPriority(player,3,1,nil,3,1,"Tornado Top")
			end
		end
			
	
		CBW_Battle.SkinVars["whirl"] = {
			weight = 110,
			shields = 1,
			special = WhirlSpecial,
			guard_enabled = true,
			guard_frame = 2,
			func_priority_ext = KineticPriorityW,
			func_exhaust = KineticExhaustW
		}
	
		WhirlBattle = true
		print("Whirl BattleMod functions have been loaded.")
	end
end)