freeslot(
	"sfx_wodbnk", // red cat sneaks in
	"sfx_whrdrl",
	"sfx_whrbnk",
	"sfx_whstdr"
)

sfxinfo[sfx_wodbnk].caption = "Wood banging"
sfxinfo[sfx_whrbnk].caption = "Funny ram go bonk"

sfxinfo[sfx_kc31].caption = "Windy takeoff"
sfxinfo[sfx_whrdrl].caption = "Drilling"
sfxinfo[sfx_whstdr].caption = "Drill Start"
sfxinfo[sfx_s251].caption = "Charging footsteps."

freeslot(
	"MT_RAMGHOST",
	"S_RAMGHOST"
)

mobjinfo[MT_RAMGHOST] = {
	spawnstate = S_RAMGHOST,
	spawnhealth = 1,
	displayoffset = 1,
	mass = 1,
	damage = 8,
	radius = 16*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY,
}

states[S_RAMGHOST] = {
	sprite = SPR_THOK,
	frame = FF_TRANS30,
	tics = 8,
	nextstate = S_NULL,
}


freeslot(
	"S_RAMSPARKS1",
	"S_RAMSPARKS2",
	"S_RAMSPARKS3",
	"S_RAMSPARKS4",
	"S_RAMSPARKS5",
	"SPR_RMSK"
)

states[S_RAMSPARKS1] = {
	sprite = SPR_RMSK,
	frame = A,
	tics = 2,
	nextstate = S_RAMSPARKS2,
}

states[S_RAMSPARKS2] = {
	sprite = SPR_RMSK,
	frame = B,
	tics = 2,
	nextstate = S_RAMSPARKS3,
}

states[S_RAMSPARKS3] = {
	sprite = SPR_RMSK,
	frame = C,
	tics = 2,
	nextstate = S_RAMSPARKS4,
}

states[S_RAMSPARKS4] = {
	sprite = SPR_RMSK,
	frame = D,
	tics = 2,
	nextstate = S_RAMSPARKS5,
}

states[S_RAMSPARKS5] = {
	sprite = SPR_RMSK,
	frame = E,
	tics = 2,
	nextstate = S_NULL,
}

//Drilling and landing animations

freeslot(
	"S_PLAY_DRILL",
	"S_PLAY_DRILL_LAND",
	"SPR2_DRIL"
)

states[S_PLAY_DRILL] = {
	sprite = SPR_PLAY,
	frame = SPR2_DRIL|FF_ANIMATE,
	tics = 2,
	nextstate = S_PLAY_DRILL,
	var1 = 3,
	var2 = 2,
}

states[S_PLAY_DRILL_LAND] = {
	sprite = SPR_PLAY,
	frame = SPR2_LAND|FF_ANIMATE,
	tics = 14,
	nextstate = S_PLAY_STND,
	var1 = 1,
	var2 = 14,
}

//Recoil Animation

freeslot(
	"S_PLAY_RECOIL",
	"SPR2_COIL"
)

states[S_PLAY_RECOIL] = {
	sprite = SPR_PLAY,
	frame = SPR2_COIL|FF_ANIMATE,
	tics = 8,
	nextstate = S_PLAY_FALL,
	var1 = 1,
	var2 = 4,
}


freeslot("S_WHIRLSMOKE1", "S_WHIRLSMOKE2", "S_WHIRLSMOKE3", "S_WHIRLSMOKE4", "S_WHIRLSMOKE5")
states[S_WHIRLSMOKE1] = {SPR_SMOK, FF_TRANS70, 2, nil, 0, 0, S_WHIRLSMOKE2}
states[S_WHIRLSMOKE2] = {SPR_SMOK, FF_TRANS80|1, 2, nil, 0, 0, S_WHIRLSMOKE3}
states[S_WHIRLSMOKE3] = {SPR_SMOK, FF_TRANS90|2, 2, nil, 0, 0, S_WHIRLSMOKE4}
states[S_WHIRLSMOKE4] = {SPR_SMOK, FF_TRANS90|3, 2, nil, 0, 0, S_WHIRLSMOKE5}
states[S_WHIRLSMOKE5] = {SPR_SMOK, FF_TRANS90|4, 2, nil, 0, 0, S_NULL}

freeslot("SPR_RMFT", "S_WHIRLTRAIL")
states[S_WHIRLTRAIL] = {SPR_RMFT, FF_TRANS20|FF_PAPERSPRITE|FF_ANIMATE,
14, nil, 6, 2, S_WHIRLSMOKE2}

freeslot(
	"MT_WHIRLWINDVORTEX",
	"S_WHIRLWINDSPLASH",
	"S_WHIRLWINDVORTEX",
	"S_RAMCHARGE",
	"SPR_WSPL",
	"SPR_WVTX",
	"SPR_RMCH"
)

mobjinfo[MT_WHIRLWINDVORTEX] = {
	spawnstate = S_WHIRLWINDVORTEX,
	spawnhealth = 1000,
	speed = 30*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPTHING|MF_NOCLIPHEIGHT,
}

states[S_WHIRLWINDSPLASH] = {SPR_WSPL, FF_TRANS50|FF_ANIMATE|A, -1, nil, 10, 2, S_NULL}
states[S_WHIRLWINDVORTEX] = {SPR_WVTX, FF_TRANS30|FF_ANIMATE|A, -1, nil, 3, 2, S_NULL}
states[S_RAMCHARGE] = {SPR_RMCH, FF_TRANS10|FF_ANIMATE|A, -1, nil, 3, 1, S_RAMCHARGE}