freeslot(
	"MT_ICESPRAY",
	"MT_THROWNICESPRAY",
	"S_ICESPRAY",
	"MT_ICESPRAYPARTICLE",
	"SPR_ICSP"
)

mobjinfo[MT_ICESPRAY] = {
	spawnstate = S_ICESPRAY,
	spawnhealth = 1000,
	speed = 30*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPTHING|MF_NOCLIPHEIGHT,
}

mobjinfo[MT_THROWNICESPRAY] = {
	spawnstate = mobjinfo[MT_ICESPRAY].spawnstate,
	spawnhealth = 1000,
	speed = mobjinfo[MT_ICESPRAY].speed,
	radius = mobjinfo[MT_ICESPRAY].radius,
	height = mobjinfo[MT_ICESPRAY].height,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY,
}

states[S_ICESPRAY] = {
	sprite = SPR_ICSP,
	tics = -1,
}

mobjinfo[MT_ICESPRAYPARTICLE] = {
	spawnstate = mobjinfo[MT_ICESPRAY].spawnstate,
	spawnhealth = 1000,
	speed = mobjinfo[MT_ICESPRAY].speed,
	radius = mobjinfo[MT_ICESPRAY].radius,
	height = mobjinfo[MT_ICESPRAY].height,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY,
}

freeslot(
	"MT_THROWNICESHARD",
	"S_THROWNICESHARD",
	"S_THROWNICESHARD_DEATH1",
	"S_THROWNICESHARD_DEATH2",
	"S_THROWNICESHARD_DEATH3",
	"SPR_ICSH",
	"SPR_ICHC",
//	"sfx_icesp2",
	"sfx_reeeee",
	"sfx_iceapp",	// red cat sneaks in
	"sfx_iceap2",
	"sfx_iceap3",
	"sfx_icebrk",
	"sfx_icebth",
	"sfx_icesrf",
	"sfx_icevan",
	"sfx_icewal",
	"sfx_toysqk"
)

sfxinfo[sfx_s3kcfl] = {
	caption = "Wind blowing",
	flags = SF_NOMULTIPLESOUND // don't destroy my eardrums
}

sfxinfo[sfx_iceapp] = {
	caption = "Ice platform spawn"
}
sfxinfo[sfx_iceap2] = {
	caption = "Ice platform spawn"
}
sfxinfo[sfx_iceap3] = {
	caption = "Ice platform spawn"
}

sfxinfo[sfx_icebth] = {
	caption = "Ice spray"
}

sfxinfo[sfx_icesrf] = {
	caption = "Ice surf start"
}

sfxinfo[sfx_icewal] = {
	caption = "Ice wall spawn"
}

sfxinfo[sfx_icevan] = {
	caption = "Ice vanishing",
	flags = SF_NOMULTIPLESOUND // don't destroy my eardrums
}

sfxinfo[sfx_toysqk] = {
	caption = "Squeak"
}

//APRIL FOOLS!
sfxinfo[sfx_reeeee] = {
	caption = "Omae Wa Mou Shindeiru"
}

mobjinfo[MT_THROWNICESHARD] = {
	spawnstate = S_THROWNICESHARD,
	deathstate = S_THROWNICESHARD_DEATH1,
	deathsound = sfx_icebrk,
	spawnhealth = 1000,
	speed = (60*FRACUNIT)*5,
	radius = 48*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY,
}

states[S_THROWNICESHARD] = {
	sprite = SPR_ICSH,
	tics = -1,
}

states[S_THROWNICESHARD_DEATH1] = {
	sprite = SPR_ICSP,
	frame = D,
	tics = 4,
	nextstate = S_THROWNICESHARD_DEATH2,
}

states[S_THROWNICESHARD_DEATH2] = {
	sprite = SPR_ICSP,
	frame = E,
	tics = 4,
	nextstate = S_THROWNICESHARD_DEATH3,
}

states[S_THROWNICESHARD_DEATH3] = {
	sprite = SPR_ICSP,
	frame = F,
	tics = 4,
	nextstate = S_NULL,
}

freeslot(
	"MT_THROWNICEMINE",
	"S_THROWNICEMINE",
	"S_THROWNTEAMICEMINE",
	"SPR_ICEB",
	"SPR_ICBC"
)

mobjinfo[MT_THROWNICEMINE] = {
	spawnstate = S_THROWNICEMINE,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
}

states[S_THROWNICEMINE] = {
	sprite = SPR_ICEB,
	tics = -1,
}

states[S_THROWNTEAMICEMINE] = {
	sprite = SPR_ICBC,
	tics = -1,
}

freeslot("MT_ICESTORMGENERATOR", "MT_ICEWALLGENERATOR", "MT_ICEWALLSEGMENT", "MT_ICEWALLGENERATOR_BATTLE", "MT_ICEWALLSEGMENT_BATTLE")
freeslot("SPR_IWAL", "SPR_IWLC")

mobjinfo[MT_ICESTORMGENERATOR] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY,
}

mobjinfo[MT_ICEWALLGENERATOR] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIPTHING,
}

mobjinfo[MT_ICEWALLSEGMENT] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	height = 256*FRACUNIT,
	radius = 0,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SHOOTABLE,
}

mobjinfo[MT_ICEWALLGENERATOR_BATTLE] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	activesound = sfx_bnce1,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_SLIDEME|MF_PUSHABLE|MF_BOUNCE,
}

mobjinfo[MT_ICEWALLSEGMENT_BATTLE] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	height = 128*FRACUNIT,
	radius = 0,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}

freeslot(
	"MT_ICEBLOCK",
	"S_ICEBLOCK",
	"MT_ICEBLOCKSOLIDCOLLIDE",
	"S_ICEBLOCKSOLIDCOLLIDE",
	"MT_ICEBLOCKWALL",
	"S_ICEBLOCKWALL",
	"SPR_ICBK"
)

// Looks familiar.
local function iceOverlay(mo)
	local function removewalls()
		if (mo.solidblockcollide and mo.solidblockcollide.valid) then
			P_RemoveMobj(mo.solidblockcollide)
		end
		for i=1,4 do
			if (mo.walls and mo.walls[i].valid) then
				P_RemoveMobj(mo.walls[i])
			end
		end
	end
	if (mo.target and mo.target.valid)
	and (mo.target.health > 0) then
		P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z)
		mo.flags2 = mo.target.flags2
		mo.eflags = mo.target.eflags
		if (mo.target.player)
		and (not mo.target.player.dirk_frozen) then
			removewalls()
			P_RemoveMobj(mo)
		end
	else
		removewalls()
		P_RemoveMobj(mo)
	end
end
addHook("MobjThinker", iceOverlay, MT_ICEBLOCK)

addHook("MobjCollide", function(mo,mo2)
	if (mo2 == mo.target) then
		return false
	end
end, MT_ICEBLOCKSOLIDCOLLIDE)

mobjinfo[MT_ICEBLOCK] = {
	spawnstate = S_ICEBLOCK,
	radius = mobjinfo[MT_PLAYER].radius,
	height = mobjinfo[MT_PLAYER].height,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT,
}

states[S_ICEBLOCK] = {
	sprite = SPR_NULL,
	tics = -1,
}

mobjinfo[MT_ICEBLOCKSOLIDCOLLIDE] = {
	spawnstate = S_ICEBLOCKSOLIDCOLLIDE,
	radius = mobjinfo[MT_PLAYER].radius,
	height = 72*FRACUNIT,
	flags = MF_SOLID,
}

states[S_ICEBLOCKSOLIDCOLLIDE] = {
	sprite = SPR_NULL,
	tics = -1,
}

mobjinfo[MT_ICEBLOCKWALL] = {
	spawnstate = S_ICEBLOCKWALL,
	radius = mobjinfo[MT_PLAYER].radius,
	height = mobjinfo[MT_PLAYER].height,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT,
}

states[S_ICEBLOCKWALL] = {
	sprite = SPR_ICBK,
	frame = FF_PAPERSPRITE,
	tics = -1,
}

//Socs done by Lach
//Ice surf

freeslot("S_PLAY_SURF")
freeslot("SPR2_GRND")

states[S_PLAY_SURF] = {
	sprite = SPR_PLAY,
	frame = SPR2_GRND,
	tics = -1,
}

//Spindash particles

freeslot("SPR_ICDH")
for i = 1,4
	freeslot("S_ICEFLAKE" + i)
	states[S_ICEFLAKE1 + i - 1] = {
		sprite = SPR_ICDH,
		tics = 7 - i,
		nextstate = S_ICEFLAKE1 + i
	}
end

//Ice energy

freeslot("S_ICEENERGY1", "S_ICEENERGY2", "S_ICEENERGY3", "S_ICEENERGY4")

states[S_ICEENERGY1] = {
	sprite = SPR_ICDH,
	frame = A,
	tics = 1,
	nextstate = S_ICEENERGY2
}

states[S_ICEENERGY2] = {
	sprite = SPR_ICDH,
	frame = B,
	tics = 1,
	nextstate = S_ICEENERGY3
}

states[S_ICEENERGY3] = {
	sprite = SPR_ICDH,
	frame = C,
	tics = 1,
	nextstate = S_ICEENERGY4
}

states[S_ICEENERGY4] = {
	sprite = SPR_ICDH,
	frame = B,
	tics = 1,
	nextstate = S_ICEENERGY1
}

states[S_ICEFLAKE1].frame = B|TR_TRANS20
states[S_ICEFLAKE2].frame = C|TR_TRANS40
states[S_ICEFLAKE3].frame = B|TR_TRANS60
states[S_ICEFLAKE4].frame = A|TR_TRANS80
states[S_ICEFLAKE4].nextstate = 0



freeslot("MT_BIGJUMPKEY")
freeslot("S_BIGJUMPKEY")
freeslot("SPR_FZBT", "SPR_FZSM")

mobjinfo[MT_BIGJUMPKEY] = {
	spawnstate = S_BIGJUMPKEY,
	height = 56*FRACUNIT,
	radius = 207*FRACUNIT,
	flags = MF_NOCLIPHEIGHT|MF_NOBLOCKMAP,
}

states[S_BIGJUMPKEY] = {
	sprite = SPR_FZBT,
	tics = -1,
}

addHook("MobjThinker", function(mo)
	if (not mo.target)
	or (mo.target and (not mo.target.valid)) then
		P_RemoveMobj(mo)
		return
	end
end, MT_BIGJUMPKEY)

//
// Ice platform
//

freeslot("MT_ICEPLATFORMTWO")
freeslot("MT_ICEPLATFORMSEGMENT")
freeslot("MT_ICEPLATFORMFLOOR")
freeslot("S_ICEPLATFORMTWO")
freeslot("S_ICEPLATFORMSEGMENT")
freeslot("S_ICEPLATFORMFLOOR")
freeslot("SPR_IPLT")
freeslot("SPR_ISPT")

mobjinfo[MT_ICEPLATFORMTWO] = {
	spawnstate = S_ICEPLATFORMTWO,
	height = 20*FRACUNIT,
	radius = 64*FRACUNIT,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_ICEPLATFORMSEGMENT] = {
	spawnstate = S_ICEPLATFORMSEGMENT,
	height = 20*FRACUNIT,
	radius = 64*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_ICEPLATFORMTWO] = {
	sprite = SPR_NULL,
	tics = -1,
}

states[S_ICEPLATFORMSEGMENT] = {
	sprite = SPR_IPLT,
	frame = FF_PAPERSPRITE,
	tics = -1,
}

mobjinfo[MT_ICEPLATFORMFLOOR] = {
	spawnstate = S_ICEPLATFORMFLOOR,
	height = 20*FRACUNIT,
	radius = 64*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_ICEPLATFORMFLOOR] = {
	sprite = SPR_ISPT,
	tics = -1,
}

//Ice platforms

freeslot("SPR_ICEC",
	"MT_FOOTFREEZE",
	"S_FOOTFREEZE",
	"MT_FOOTFREEZETWO",
	"S_FOOTFREEZETWO")

mobjinfo[MT_FOOTFREEZE] = {
	spawnstate = S_FOOTFREEZE,
	height = 20*FRACUNIT,
	radius = 24*FRACUNIT,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_FOOTFREEZE] = {
	sprite = SPR_ICEC,
	frame = B,
	tics = 3*TICRATE
}

mobjinfo[MT_FOOTFREEZETWO] = {
	spawnstate = S_FOOTFREEZETWO,
	height = 20*FRACUNIT,
	radius = 64*FRACUNIT,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_FOOTFREEZETWO] = {
	sprite = SPR_NULL,
	tics = 3*TICRATE
}

//Ice shatter particles

freeslot("SPR_IGIB",
	"MT_ICEGIB",
	"S_ICEGIB")

mobjinfo[MT_ICEGIB] = {
	spawnstate = S_ICEGIB,
	height = 20*FRACUNIT,
	radius = 24*FRACUNIT,
	flags = MF_NOCLIPTHING
}

states[S_ICEGIB] = {
	sprite = SPR_IGIB,
	tics = 35
}

//
// Super Orb
//

freeslot("MT_DIRK_SUPERAURA")

mobjinfo[MT_DIRK_SUPERAURA] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	dispoffset = -10,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

//Super particles

freeslot("SPR_KICE")
for i = 1,5
	freeslot("S_SUPERICEENERGY" + i)
	states[S_SUPERICEENERGY1 + i - 1] = {
		sprite = SPR_KICE,
		tics = 7 - i,
		nextstate = S_SUPERICEENERGY1 + i
	}
end

states[S_SUPERICEENERGY1].frame = A|TR_TRANS30
states[S_SUPERICEENERGY2].frame = B|TR_TRANS30
states[S_SUPERICEENERGY3].frame = C|TR_TRANS30
states[S_SUPERICEENERGY4].frame = B|TR_TRANS30
states[S_SUPERICEENERGY5].frame = A|TR_TRANS30
states[S_SUPERICEENERGY5].nextstate = 0

//
// Idle animation
//

freeslot("S_DIRK_IDLE")

states[S_DIRK_IDLE] = {
	sprite = SPR_PLAY,
	frame = A,
	tics = -1,
}

freeslot("MT_FLOATINGICERING", "S_FLOATINGICERING")
freeslot("SPR_RNGC")

mobjinfo[MT_FLOATINGICERING] = {
	spawnstate = S_FLOATINGICERING,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY,
}

states[S_FLOATINGICERING] = {
	sprite = SPR_RNGC,
	frame = FF_ANIMATE,
	var1 = X,
	var2 = 1,
	tics = -1,
}

freeslot("S_PLAY_FROZEN")

states[S_PLAY_FROZEN] = {
	sprite = SPR_PLAY,
	tics = -1
}

//APRIL FOOLS!
freeslot("S_PLAY_NANI")
freeslot("SPR2_NANI")

states[S_PLAY_NANI] = {
	sprite = SPR_PLAY,
	frame = SPR2_NANI,
	tics = -1,
}