//Custom Skincolors

//Colored based around the Team Kinetic in my "Kinetic Universe" lore project

freeslot("SKINCOLOR_ADMIRE", "SKINCOLOR_WINDY", "SKINCOLOR_HONEY", "SKINCOLOR_ROCKY")
skincolors[SKINCOLOR_ADMIRE] = {
    name = "Admire",
    ramp = {131,134,136,154,155,156,157,158,158,169,169,253,254,254,30,31},
    invcolor = SKINCOLOR_RUST,
    invshade = 11,
    chatcolor = V_BLUEMAP,
    accessible = true
}

skincolors[SKINCOLOR_WINDY] = {
    name = "Windy",
    ramp = {0,0,128,129,129,132,133,134,135,142,143,118,119,119,30,31},
    invcolor = SKINCOLOR_CARBON,
    invshade = 6,
    chatcolor = V_GRAYMAP,
    accessible = true
}

skincolors[SKINCOLOR_HONEY] = {
    name = "Honey",
    ramp = {0,0,81,82,83,64,52,53,55,58,60,42,44,71,46,47},
    invcolor = SKINCOLOR_CORNFLOWER,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = true
}

skincolors[SKINCOLOR_ROCKY] = {
    name = "Rocky",
    ramp = {0,81,49,51,53,55,38,40,40,207,186,186,187,187,254,254},
    invcolor = SKINCOLOR_COBALT,
    invshade = 14,
    chatcolor = V_ORANGEMAP,
    accessible = true
}

// Custom Super Colors

freeslot(
"SKINCOLOR_SUPERICY1",
"SKINCOLOR_SUPERICY2",
"SKINCOLOR_SUPERICY3",
"SKINCOLOR_SUPERICY4",
"SKINCOLOR_SUPERICY5",
"SKINCOLOR_SUPERWIND1",
"SKINCOLOR_SUPERWIND2",
"SKINCOLOR_SUPERWIND3",
"SKINCOLOR_SUPERWIND4",
"SKINCOLOR_SUPERWIND5",
"SKINCOLOR_SUPERLIME1",
"SKINCOLOR_SUPERLIME2",
"SKINCOLOR_SUPERLIME3",
"SKINCOLOR_SUPERLIME4",
"SKINCOLOR_SUPERLIME5")

skincolors[SKINCOLOR_SUPERICY1] = {
    name = "Super Icy 1",
    ramp = {0,0,0,0,0,0,0,0,0,0,128,129,130,131,132,133},
    accessible = false
}

skincolors[SKINCOLOR_SUPERICY2] = {
    name = "Super Icy 2",
    ramp = {0,0,0,0,128,128,129,129,130,130,131,131,132,132,133,133},
    accessible = false
}

skincolors[SKINCOLOR_SUPERICY3] = {
    name = "Super Icy 3",
    ramp = {0,0,128,128,129,129,130,130,131,131,132,132,133,133,134,134},
    accessible = false
}

skincolors[SKINCOLOR_SUPERICY4] = {
    name = "Super Icy 4",
    ramp = {0,128,129,130,131,132,133,134,149,149,165,166,167,168,169,253},
    accessible = false
}

skincolors[SKINCOLOR_SUPERICY5] = {
    name = "Super Icy 5",
    ramp = {128,129,130,131,132,133,134,149,149,165,166,167,168,169,253,254},
    accessible = false
}

skincolors[SKINCOLOR_SUPERWIND1] = {
    name = "Super Wind 1",
    ramp = {0,0,0,0,0,0,0,0,0,0,128,128,129,129,130,130},
    accessible = false
}

skincolors[SKINCOLOR_SUPERWIND2] = {
    name = "Super Wind 2",
    ramp = {0,0,0,128,128,128,129,129,129,130,130,130,131,131,141,141},
    accessible = false
}

skincolors[SKINCOLOR_SUPERWIND3] = {
    name = "Super Wind 3",
    ramp = {0,0,128,128,129,129,130,130,131,131,141,141,142,142,126,126},
    accessible = false
}

skincolors[SKINCOLOR_SUPERWIND4] = {
    name = "Super Wind 4",
    ramp = {0,128,129,129,130,130,131,131,141,141,142,142,126,126,127,127},
    accessible = false
}

skincolors[SKINCOLOR_SUPERWIND5] = {
    name = "Super Wind 5",
    ramp = {128,129,130,130,131,131,141,141,142,142,126,126,127,127,118,118},
    accessible = false
}

skincolors[SKINCOLOR_SUPERLIME1] = {
    name = "Super Lime 1",
    ramp = {0,0,0,0,0,0,0,0,0,0,80,80,81,82,83,72},
    accessible = false
}

skincolors[SKINCOLOR_SUPERLIME2] = {
    name = "Super Lime 2",
    ramp = {0,80,81,82,83,83,72,72,188,188,188,188,188,188,189,190},
    accessible = false
}

skincolors[SKINCOLOR_SUPERLIME3] = {
    name = "Super Lime 3",
    ramp = {81,82,83,83,72,72,188,188,188,188,188,188,189,190,191,106},
    accessible = false
}

skincolors[SKINCOLOR_SUPERLIME4] = {
    name = "Super Lime 4",
    ramp = {83,83,72,72,188,188,188,188,188,188,189,190,191,106,107,108},
    accessible = false
}

skincolors[SKINCOLOR_SUPERLIME5] = {
    name = "Super Lime 5",
    ramp = {72,72,188,188,188,188,188,188,189,190,191,106,107,108,109,109},
    accessible = false
}