freeslot(
	"sfx_flwcrg", // red cat sneaks in
	"sfx_flwchg",
	"sfx_flwfil",
	"sfx_stgsrk"
)

sfxinfo[sfx_flwcrg].caption = "Preparing attack..."
sfxinfo[sfx_flwchg].caption = "Attack ready!"
sfxinfo[sfx_flwfil].caption = "Refilled!"
sfxinfo[sfx_stgsrk].caption = "Spike Strike."

freeslot("MT_VESOLA_STINGER", 
"S_VESOLASTING_NOROTATE", 
"S_VESOLASTING_PLUSROTATE", 
"S_VESOLASTING_MINUSROTATE",
"S_VESOLASTING_PAIN",
"S_VESOLASTING_GASP",
"S_VESOLASTING_EDGE",
"S_VESOLASTING_STRIKE1",
"S_VESOLASTING_STRIKE2",
"S_VESOLASTING_STRIKE3",
"S_VESOLASTING_STRIKE4"
)

//Stinger FollowMobj


mobjinfo[MT_VESOLA_STINGER] = {
	spawnstate = S_INVISIBLE, 
	spawnhealth = 1000, 
	radius = 16*FRACUNIT, 
	height = 48*FRACUNIT,
	dispoffset = 2,
	reactiontime = 8,
	mass = 16,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
}

states[S_VESOLASTING_NOROTATE] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL0,
	tics = 5,
	nextstate = S_VESOLASTING_NOROTATE,
}

states[S_VESOLASTING_PLUSROTATE] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL1,
	tics = -1,
	nextstate = S_VESOLASTING_PLUSROTATE,
}

states[S_VESOLASTING_MINUSROTATE] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL2,
	tics = -1,
	nextstate = S_VESOLASTING_MINUSROTATE,
}

states[S_VESOLASTING_PAIN] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL3,
	tics = 35,
	nextstate = S_VESOLASTING_PAIN,
}

states[S_VESOLASTING_GASP] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL4,
	tics = 35,
	nextstate = S_VESOLASTING_GASP,
}

states[S_VESOLASTING_EDGE] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL5|FF_ANIMATE,
	tics = 35,
	nextstate = S_VESOLASTING_EDGE,
	var2 = 2,
}

states[S_VESOLASTING_STRIKE1] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL0|A,
	tics = 2,
	nextstate = S_VESOLASTING_STRIKE2,
}

states[S_VESOLASTING_STRIKE2] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL2|D,
	tics = 2,
	nextstate = S_VESOLASTING_STRIKE3,
}

states[S_VESOLASTING_STRIKE3] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL6,
	tics = 2,
	nextstate = S_VESOLASTING_STRIKE4,
}

states[S_VESOLASTING_STRIKE4] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL7,
	tics = 70,
	nextstate = S_VESOLASTING_STRIKE4,
}

//Custom frames

freeslot("S_PLAY_STING") 

states[S_PLAY_STING] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEE,
	tics = 3,
	nextstate = S_PLAY_FALL,
}


//Papersprited Wings

freeslot("MT_VESOLA_WING")
mobjinfo[MT_VESOLA_WING] = {
	spawnstate = S_INVISIBLE, 
	spawnhealth = 1000, 
	radius = 16*FRACUNIT, 
	height = 16*FRACUNIT, 
	dispoffset = 1,
	reactiontime = 8,
	mass = 16,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
}


freeslot(
	"MT_FLOWERGHOST",
	"S_FLOWERGHOST"
)

mobjinfo[MT_FLOWERGHOST] = {
	spawnstate = S_FLOWERGHOST,
	spawnhealth = 1,
	displayoffset = 1,
	mass = 1,
	damage = 8,
	radius = 16*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY,
}

states[S_FLOWERGHOST] = {
	sprite = SPR_THOK,
	frame = FF_TRANS50,
	tics = 8,
	nextstate = S_NULL,
}

//Petal Twirl

freeslot("MT_PETALTWIRLPIECE",
		"S_PETALTWIRL",
		"SPR_PDTW"
)

mobjinfo[MT_PETALTWIRLPIECE] = {
	spawnstate = S_PETALTWIRL,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_MISSILE,
}

mobjinfo[MT_PETALTWIRLPIECE].name = "Petal Twirl"

states[S_PETALTWIRL] = {
	sprite = SPR_PDTW,
	frame = A|FF_ANIMATE,
	tics = -1,
	nextstate = S_PETALTWIRL,
	var1 = 11,
	var2 = 6
}

//Flower Trampoline

freeslot("MT_FLOWERTRAMPOLINESPAWN",
		"MT_FLOWERTRAMPOLINESTEM",
		"MT_FLOWERTRAMPOLINEPLAT",
		"MT_FLOWERTRAMPOLINEPEDAL",
		"S_FLOWERDIRTUPRISE",
		"S_FLOWERDIRTPILE",
		"S_FLOWERTRAMPOLINESTEM",
		"S_FLOWERTRAMPOLINESTEM2",
		"S_FLOWERTRAMPOLINEPLAT",
		"S_FLOWERTRAMPOLINEPEDAL",
		"SPR_FTBS",
		"SPR_FTDT",
		"SPR_FTPD",
		"SPR_FTVN"
)

mobjinfo[MT_FLOWERTRAMPOLINESPAWN] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIPTHING,
}

states[S_FLOWERDIRTUPRISE] = {
	sprite = SPR_FTDT,
	frame = A|FF_ANIMATE,
	tics = 18,
	nextstate = S_FLOWERDIRTPILE,
	var1 = 8,
	var2 = 2,
}

states[S_FLOWERDIRTPILE] = {
	sprite = SPR_FTDT,
	frame = I,
	tics = 1,
	nextstate = S_FLOWERDIRTPILE,
}

mobjinfo[MT_FLOWERTRAMPOLINESTEM] = {
	spawnstate = S_FLOWERTRAMPOLINESTEM,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOGRAVITY,
}

states[S_FLOWERTRAMPOLINESTEM] = {
	sprite = SPR_FTVN,
	frame = A,
	tics = 1,
	nextstate = S_FLOWERTRAMPOLINESTEM,
}

states[S_FLOWERTRAMPOLINESTEM2] = {
	sprite = SPR_FTVN,
	frame = B,
	tics = 1,
	nextstate = S_FLOWERTRAMPOLINESTEM2,
}

mobjinfo[MT_FLOWERTRAMPOLINEPLAT] = {
	spawnstate = S_FLOWERTRAMPOLINEPLAT,
	spawnhealth = 1000,
	radius = 64*FRACUNIT,
	height = FRACUNIT,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}

states[S_FLOWERTRAMPOLINEPLAT] = {
	sprite = SPR_FTBS,
	frame = A,
	tics = 1,
	nextstate = S_FLOWERTRAMPOLINEPLAT,
}

mobjinfo[MT_FLOWERTRAMPOLINEPEDAL] = {
	spawnstate = S_FLOWERTRAMPOLINEPEDAL,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_SOLID|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOGRAVITY,
}

states[S_FLOWERTRAMPOLINEPEDAL] = {
	sprite = SPR_FTPD,
	frame = A,
	tics = 1,
	nextstate = S_FLOWERTRAMPOLINEPEDAL,
}

//Vine Spikes

freeslot("MT_VINESPIKESPAWN",
		"MT_VINESPIKE",
		"S_VINESPIKE",
		"SPR_FSKP",
		"SPR_FSKC"
)

mobjinfo[MT_VINESPIKESPAWN] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIPTHING,
}

mobjinfo[MT_VINESPIKE] = {
	spawnstate = S_VINESPIKE,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 128*FRACUNIT,
	speed = 1,
	flags = MF_SCENERY,
}

mobjinfo[MT_VINESPIKE].name = "Vine Spike"

states[S_VINESPIKE] = {
	sprite = SPR_FSKP,
	frame = A,
	tics = 1,
	nextstate = S_VINESPIKE,
}

//VFX and particles (Vary in scenarios)

freeslot("MT_PETALATTACK",
		"MT_CHARGINGVFX",
		"MT_PETALPARTICLE",
		"S_PETALATTACK",
		"S_CHARGINGMOVE",
		"S_PETALPARTICLE",
		"SPR_PTBL",
		"SPR_PTCH"
)

//Petal Bullets

mobjinfo[MT_PETALATTACK] = {
	spawnstate = S_PETALATTACK,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	speed = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP,
}

mobjinfo[MT_PETALATTACK].name = "Petal Bullet"

states[S_PETALATTACK] = {
	sprite = SPR_PTBL,
	frame = A|FF_ANIMATE,
	tics = -1,
	nextstate = S_PETALATTACK,
	var1 = 5,
	var2 = 6
}
	
mobjinfo[MT_PETALPARTICLE] = {
	spawnstate = S_PETALPARTICLE,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	speed = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP,
}

states[S_PETALPARTICLE] = {
	sprite = SPR_PTBL,
	frame = A|FF_ANIMATE,
	tics = -1,
	nextstate = S_PETALPARTICLE,
	var1 = 5,
	var2 = 6
}

mobjinfo[MT_CHARGINGVFX] = {
	spawnstate = S_CHARGINGMOVE,
	spawnhealth = 1000,
	speed = 30*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPTHING|MF_NOCLIPHEIGHT,
}


states[S_CHARGINGMOVE] = {
	sprite = SPR_PTCH,
	frame = A|FF_ANIMATE|FF_TRANS40,
	tics = -1,
	nextstate = S_CHARGINGMOVE,
	var1 = 3,
	var2 = 2
}

//Thinker when the object does get flung in the air, we should kill it at its peak.

function A_LaunchedEnemy(fling)
	if fling.launched == nil then
		fling.rollangle = 0
		fling.state = mobjinfo[fling.type].spawnstate
		return
	end
	
	fling.sprite = fling.baseSprite
	fling.frame = fling.baseFrame
	
	if fling.flytime == nil then
		fling.flytime = 0
	end
	fling.flytime = $+1
	if fling.flytime == 1
		S_StartSound(fling.launched.target, sfx_bsnipe)
	end
	
	fling.rollangle = ANG10*(leveltime*3)
	P_SetObjectMomZ(fling, 24*FRACUNIT, false)
	P_SpawnMobjFromMobj(fling, 0,0,0, MT_SMOKE).fuse = TICRATE
	
	if P_IsObjectOnGround(fling)
		fling.launched = nil
		fling.rollangle = 0
		fling.state = mobjinfo[fling.type].spawnstate
		return
	end
	
	if fling.flytime >= TICRATE and fling.launched.valid then
		local pmo = fling.launched.target
		if pmo and pmo.valid then
			P_DamageMobj(fling, fling.launched, pmo)
		else
			P_DamageMobj(fling, fling.launched)
		end
	end
	
	local onCeiling = false
    if fling.eflags & MFE_VERTICALFLIP then
        if (fling.z <= fling.floorz) then
            onCeiling = true
        end
    elseif (fling.z+fling.height >= fling.ceilingz) then
        onCeiling = true
    end
	
	//Safety check in case enemies get locked on the ceiling
	if onCeiling then
		P_DamageMobj(fling, fling.launched, pmo)
	end
end

freeslot("S_LAUNCHEDENEMY")
states[S_LAUNCHEDENEMY] = {
	sprite = SPR_NULL,
	action = A_LaunchedEnemy,
	tics = 1, nextstate = S_LAUNCHEDENEMY,
}

local function petalfollow(petal)
	local player = nil
	local pmo = nil
	if (petal.target and petal.target.valid and petal.target.player) then
		pmo = petal.target
		player = pmo.player
		
		petal.momx = petal.target.momx
		petal.momy = petal.target.momy
	end
end

addHook("MobjThinker", petalfollow, MT_PETALPARTICLE)