/*
Whirl's Bot abilites
	by SMS Alfredo
Edit from Dirk's Bot abilites
	by Lach
*/
addHook("BotTiccmd", function(bot,cmd)
	local player = players[0]
	local mo = players[0].mo
	
	if player.exiting then  //Have we finished the level? If so, disable the bot ability
		return
	end
	
	//Dance along!
	//Also accounts for Dirk as well since I don't wanna bother editting his Lua
	if bot.mo and bot.mo.skin == "dirk" or bot.mo.skin == "whirl" or bot.mo.skin == "vesola" and player and mo
		if player.teamkineticrpg or player.skipsmug or player.milnekick
			bot.teamkineticrpg = true
		elseif bot.teamkineticrpg
			if bot.mo.state == S_PLAY_CLIMB
				bot.mo.state = S_PLAY_STND
			end
			bot.teamkineticrpg = false
		end
	end
	
	if bot.mo and bot.mo.skin == "whirl" and players[0].mo
	
		if bot.mo.whirlind
			if P_AproxDistance(bot.mo.z-mo.z,P_AproxDistance(bot.mo.x-mo.x,bot.mo.y-mo.y)) <= bot.mo.radius*2
			and player.speed == 0 and P_IsObjectOnGround(bot.mo)
			and not bot.mo.whirljump and not bot.whirltornadojump
				bot.mo.whirlind.flags2 = $ & ~MF2_DONTDRAW
				bot.jumpfactor = FRACUNIT
			else
				bot.mo.whirlind.flags2 = $|MF2_DONTDRAW
				bot.jumpfactor = skins[bot.mo.skin].jumpfactor
			end
		else
			local ind = P_SpawnMobj(bot.mo.x, bot.mo.y, bot.mo.z, MT_OVERLAY)
			ind.target = bot.mo
			ind.state = S_FLIGHTINDICATOR
			ind.flags2 = $|MF2_DONTDRAW
			bot.mo.whirlind = ind
		end

		if bot.mo.whirljump
			if bot.whirltornadojump
				if player.cmd.buttons&BT_SPIN and mo.tracer == bot.mo
				and bot.mo.momz*P_MobjFlip(bot.mo) <= 6*bot.mo.scale
					bot.pflags = $&~PF_JUMPDOWN
				elseif (P_IsObjectOnGround(mo) or mo.standonice)
				and bot.mo.momz*P_MobjFlip(bot.mo) <= 6*bot.mo.scale
					local floor = P_FloorzAtPos(bot.mo.x, bot.mo.y, bot.mo.z, bot.mo.height)
					if (bot.mo.eflags&MFE_VERTICALFLIP)
						if bot.mo.ceilingz == P_FloorzAtPos(bot.mo.x, bot.mo.y, bot.mo.z, bot.mo.height)
							floor = bot.mo.floorz-bot.mo.height
						else
							floor = bot.mo.ceilingz-bot.mo.height
						end
					end
					if abs(floor - bot.mo.z) > bot.height*4
						bot.pflags = $&~PF_JUMPDOWN
					end
				end
				if mo.tracer == bot.mo
					bot.mo.angle = player.cmd.angleturn<<16
					mo.angle = bot.mo.angle
					cmd.forwardmove = player.cmd.forwardmove
					cmd.sidemove = player.cmd.sidemove
				end
				cmd.buttons = $ | BT_JUMP
			else
				if abs(bot.mo.momz) > 4*mo.scale/(mo.eflags & MFE_UNDERWATER and 3 or 1)
					cmd.buttons = $ | BT_JUMP
				else
					cmd.buttons = $ & ~BT_JUMP
				end
			end
			if P_IsObjectOnGround(bot.mo)
				bot.mo.whirljump = nil
				cmd.buttons = $ & ~BT_JUMP
			end
			return true
		end

		if player.cmd.buttons & BT_JUMP
		and not (player.pflags & PF_THOKKED)
		and player.pflags & PF_JUMPED
		and P_MobjFlip(mo)*mo.momz > 0
		and P_IsObjectOnGround(bot.mo)
		and P_AproxDistance(bot.mo.z-mo.z,P_AproxDistance(bot.mo.x-mo.x,bot.mo.y-mo.y)) <= bot.mo.radius*2
			bot.mo.whirljump = true
			bot.mo.angle = mo.angle
			cmd.buttons = $ | BT_JUMP
			return true
		end
	end
end)